package Simusol::Evaluaciones;
use Simusol::Ayudas;
use Simusol::Auxiliares;
use Simusol::GlobalesSimusol;
use Simusol::Termicos;
use Simusol::Evaluaciones2;
use warnings;
use strict;
use Data::Dumper; 
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);

     @ISA=qw(Exporter);
     @EXPORT=qw(&agregar_comentario
                &aumentar_SUST
                &crear_SUSTn_SUSTadpSs
                &evaluar_ques
                &evaluar_funcion
                &evaluar_lista_cruda_numeros
                &evaluar_numero
                &evaluar_tiparg_refarg
                &gpr_gsu
                &interpretar_h
                &pegar &pegar3
                &sust_tokear &sust_token_SUST
                &sust_token_token
                &sustituir_SUST
                &simplificar_valores
                &token_2_tipotok
                &tratar_tipo_coma  
    );
};                
END();
# ---------------------------------------------------------------------------
sub acabar_agrupar_argus_g{
  comfin('comE acabar_agrupar_argus_g',@_);
  my ($ref,$parte0,$tiparge,$parte2,$refarg0,$refarge,$refarg2,$func,$cuantos)
      = @_; my $coderr = '';
  my ($tiparg,$refarg);
  if ($cuantos == 1) { # puede ser numero pos o neg u otro
      $parte0 =~ s/g.$//; $parte2 =~ s/^.//; pop @$refarg0;
      ($tiparg,$refarg)
        = pegar3($parte0,$tiparge,$parte2,$refarg0,$refarge,$refarg2,'[',']');
      return $coderr, $tiparg,$refarg;
  } else {# hay no numericos
      if ($refarge->[0] eq '-1' and $func eq 'QPRODUCTO') {
          impr_debug(__LINE__.' Eval $tiparge,$refarge'
		,[$tiparge,'||',@$refarge]);
          shift @$refarge; $tiparge =~ s/^\w,//;
          impr_debug(__LINE__.' Eval $tiparge,$refarge'
		,[$tiparge,'||',@$refarge]);
          if ($cuantos > 2) {
              $parte0 =~ s/(\w)\($/-$1\[/; $parte2 =~ s/^\)/\]/; 
          } else {
              $parte0 =~ s/\w.$/-/;$parte2 =~ s/^.//;
              pop @$refarg0;
              impr_debug(__LINE__.' Eval $parte0,$tiparge,$parte2'
			 ,[$parte0,'||',$tiparge,'||',$parte2]);
          };
          $cuantos --; 
      } else { 
          $parte0 =~ s/\($/[/; $parte2 =~ s/^\)/]/;
      };  
      $tiparg = $parte0 . $tiparge . $parte2;
      @$refarg = (@$refarg0,@$refarge,@$refarg2);
  };
  $cuantos >1 and $ref->{usog}->{$func}->{$cuantos} ++;  #en para_simp  
  comfin('finE acabar_agrupar_argus_g',$tiparg,@$refarg);
  return $coderr,$tiparg,$refarg;
}#acabar_agrupar_argus_g
# ---------------------------------------------------------------------------
sub agrupar_argus_g{
  # todos los argumentos son atomicos
  comfin('comE agrupar_argus_g',@_);
  my ($ref,$tiparg,$refarg,$func) = @_; my ($coderr,$mensaje) = ('','');;
  ($coderr,my @listipargs) = juntar_por_paren_rec(',',split(/,/,$tiparg));
  $coderr and error_progr($ref,__LINE__." Eval $coderr");
  my ($nuerefarg,$refargotros,$refargnums) = ([],[],[]);
  my ($nuetiparg,$tipargnums,$tipargotros) = ('','','');
  my (@listipargnums,@lisvalorcitos,@listipargotros);
  my ($ope,$identity) =('*', 1); 
  $func eq 'QSUMA' and do {($ope,$identity) = ('+',0)};
  foreach my $tipargcito (@listipargs) {
      impr_debug(__LINE__.' Eval $tipargcito',$tipargcito); 
      my $tipargcitoprov = $tipargcito;
      my $refargcito = []; my $otros = ''; my ($valorcito,$tipito) = ('','');
      $tipargcito =~ /[abdghpqtsSwW]/ and $otros = 1;
      push @$refargcito,shift @$refarg;
      impr_debug(__LINE__.' Eval $tipargcito,$otros',[$tipargcito,$otros]); 
      if ($otros) {
          push @listipargotros,$tipargcito; 
          push @$refargotros,@$refargcito;
      } else {
	  $valorcito = tiparg_refarg_2_valor_talcual(
            $tipargcito,$refargcito,'Eval '.__LINE__);
          $valorcito eq $identity and next;
          push @lisvalorcitos,$valorcito;
      };
  }; #foreach
  impr_debug(__LINE__.' Eval @listipargotros',\@listipargotros);
  impr_debug(__LINE__.' Eval @lisvalorcitos',\@lisvalorcitos);
  if (@lisvalorcitos) {
      my $valornums = join $ope,@lisvalorcitos;
      ($coderr,$mensaje,$valornums) = evaluar_numero( $valornums);
      $coderr and return $coderr;
      if ($valornums != $identity) {
           @$nuerefarg = ($valornums); 
          if ($valornums > 0) {$nuetiparg = 'n'; 
          } elsif ($valornums < 0) {$nuetiparg = 'o'
          } else {# $valornums eq 0; $func es QPRODUCTO
             comfin('finE agrupar_argus_g','','n',0,1);
             return '','n',[0],1;
          };
      };
  };
  if (@listipargotros) {
      $tipargotros = join ',',@listipargotros;
      if ($nuetiparg) {
	  $nuetiparg .= ','. $tipargotros; push @$nuerefarg,@$refargotros;
      } else {$nuetiparg = $tipargotros; @$nuerefarg = @$refargotros;
      };
  };
  my $cuantos = ($nuetiparg =~ tr/,//) +1;
  comfin('finE agrupar_argus_g',$coderr,$nuetiparg,$nuerefarg,$cuantos);
  return '',$nuetiparg,$nuerefarg,$cuantos;
}
# ---------------------------------------------------------------------------
sub agrupar_terms_num{
# no hay funciones calculables ni parentesis puros calculables
  comfin('comE agrupar_terms_num',@_);
  my ($tiparg,$refarg) = @_;
  my $tipargori = $tiparg; 
  my ($coderr,$mensaje) = ('','');
  $tiparg = '&' .$tiparg.'&';
  $tiparg =~ s/([^&])([\+\-])/$1&$2/g;
#  impr_debug(__LINE__.' Eval $tiparg', $tiparg);     
  my @listerms = split (/&/,$tiparg);shift @listerms;# el nulo;
  impr_debug(__LINE__.' Eval @listerms',\@listerms);
  #los terminos precedidos por su signo excepto el primero
  ($coderr,@listerms) = juntar_por_paren_cur('',@listerms);
  $coderr and do{
     comfin('finE agrupar_terms_num','40',$coderr);
     return 40,$coderr;
  }; 
  impr_debug(__LINE__.' Eval $tiparg,@listerms'
		     ,[$tiparg,'||',@listerms]);
  map(s/&/+/g,@listerms);map(s/\+\-/-/g,@listerms);
  impr_debug(__LINE__.' Eval @listerms',Dumper \@listerms);
  # seguro que al menos hay uno de cada clase
  my (@listermsotros,@listermsnums);
  my ($tipargnums,$tipargotros) = ('','');
  my ($refargotros,$refargnums) = ([],[]);
  foreach my $tipargcito (@listerms) {
      my $tipargcitoprov = $tipargcito;
      my $refargcito = []; my $otros = '';
      $tipargcito =~ /[abghkpPqtsSwW]/ and $otros = 1;
      while ($tipargcitoprov =~ s/^(\W*)\w//) {
          push @$refargcito,shift @$refarg;
      };
      impr_par(__LINE__.' Eval', $tipargcito,$refargcito);
      if ($otros) {
          $tipargotros .= $tipargcito;
          push @$refargotros,@$refargcito;
      } else {
          $tipargnums .= $tipargcito;
          push @$refargnums,@$refargcito;
      };
  };
  impr_par(__LINE__.' Eval',$tipargotros,$refargotros);
  impr_par(__LINE__.' Eval',$tipargnums,$refargnums);
  if (@$refargnums) { 
      ($coderr,$mensaje,$tiparg,$refarg)
         = Simusol::Evaluaciones2::evaluar_tiparg_refarg_numerico(
             $tipargnums,$refargnums);    
      if ($coderr) {
          mensajear($mensaje);
          comfin('finE agrupar_terms_num',$coderr);
          return $coderr;
      };
  } else {
      $tiparg = ''; $refarg = [];
  };
  if ($tiparg eq 'n' and $refarg->[0] == 0) { 
      $tiparg = ''; $refarg = [];
  };
  impr_par(__LINE__.' Eval',$tiparg,$refarg);
  if ($tiparg ne '' and $tipargotros ne '') { 
      $tipargotros =~ /^[\+\-]/ or $tipargotros = '+'.$tipargotros;
  } elsif ($tiparg eq '') {
      $tipargotros =~ s/^\+//;
  };
  $tiparg .= $tipargotros; push @$refarg,@$refargotros;
  comfin('finE agrupar_terms_num',$coderr,$tiparg,'||',@$refarg);
  return $coderr,$tiparg,$refarg;
}#agrupar_terms_num
# ---------------------------------------------------------------------------
sub aumentar_SUST{
  comfin('comE aumentar_SUST',@_);
  my ($ref,$tipo,$cosa) = @_;
  $ref->{SUSTnoSsadp}->{$cosa} = 1;
  if ($tipo =~ /[noSs]/) {
      $ref->{SUSTadp}->{$cosa} and delete $ref->{SUSTadp}->{$cosa};
      $ref->{SUSTnoSs}->{$cosa} = 1;
      if ($tipo =~ /[no]/) {
          $ref->{SUSTno}->{$cosa} = 1;
      } elsif ($tipo =~ /[Ss]/) {
          $ref->{SUSTSs}->{$cosa} = 1;
      };
   } else {
          $ref->{SUSTadp}->{$cosa} = 1;
   };
  impr_SUST('',$ref);
  comfin('finE aumentar_SUST');
}#aumentar_SUST'
# ---------------------------------------------------------------------------
sub definir_gpr_gsu{
  comfin('comE definir_gpr_gsu',@_);
  my ($ref, $cuantos,$ope) = @_;
  my $letraQ = 'P'; $ope eq '+' and $letraQ = 'S'; 
  my $func = "Q$cuantos$letraQ";
  impr_debug(__LINE__.' Eval func',$func); 
  if (defined $ref->{TIPOTOK}->{$func}) {
      comfin('finEE definir_gpr_gsu',$func);
      return $func;
  };
  my @listiparg;  
  my @virtuales = (1..$cuantos);
  map (do {push @listiparg,'W'}, @virtuales);
  map ($_ = "XX$_", @virtuales);
  impr_debug(__LINE__.' Eval @virtuales',\@virtuales);
  my $tiparg = join $ope, @listiparg;
  my $valor = join $ope, @virtuales;
  cargar_datos_tipotok($ref,'FUNCIONES',"$func",'Q',
       $valor,'x',$tiparg,\@virtuales);
  impr_dat(__LINE__.' Eval definir gpr_gsu',$func,$ref,'dgg');
  $ref->{listaargFUNCION}->{$func} = \@virtuales;# en gpr_gsu
#  $ref->{USA}->{$func} = 1;
#  impr_debug(__LINE__.' Eval USA',$ref->{USA});
  comfin('finE definir_gpr_gsu',$func);
  return $func;
}#definir_gpr_gsu
# ----------------------------------------------------------------------------
sub crear_SUSTn_SUSTadpSs{# y hace la sustiucion del ultimo
  # aqui no conviene usar agregar_comentarios directamente, sino ir juntando
  # esos comentarios
  comfin('comE crear_SUSTn_SUSTadp', @_);
  my $ref = $_[0];my $coderr = '';
  $ref->{SUSTno} = {};$ref->{SUSTSs} = {}; $ref->{SUSTadp} = {};
  my @posibles
    = grep($ref->{TIPOTOK}->{$_} =~ /[adpP]/, sort keys %{$ref->{TIPOTOK}});
  impr_debug(__LINE__.' Eval @posibles',\@posibles);
  foreach my $cosa (@posibles) {
      impr_dat(__LINE__.' Eval principal inicial',$cosa,$ref,'cSS');
      my @listavalores;
      my $valor = $ref->{VALOR}->{$cosa};
      my $tipo = $ref->{TIPO}->{$cosa};
      next unless $tipo =~ /[noSsadp]/;
      aumentar_SUST($ref,$tipo,$cosa);
      $tipo = $ref->{TIPO}->{$valor};
      unshift @listavalores,$valor;
#      impr_dat(__LINE__.' Eval principal antes ciclo',$cosa,$ref,'cSS');
      until (not defined $tipo  or $tipo !~ /[adp]/) {
          impr_dat(__LINE__.' Eval auxiliar ciclo adp',$valor,$ref,'cSS');
          $valor = $ref->{VALOR}->{$valor}; 
          unshift @listavalores,$valor;
          $tipo = $ref->{TIPO}->{$valor};
      };#until
#      impr_dat(__LINE__.' Eval principal luego ciclo',$cosa,$ref,'cSS');
      if (defined $tipo) {# y $tipo !~ /[adp]
          if ($tipo =~ /[noSsw]/) {
 #             impr_dat(__LINE__.' Eval auxiliar noSws',$valor,$ref,'cSS');
              copiar_cua_datos($ref,$valor,$cosa);
              my @listacomvalor;
              unshift @listacomvalor
                ,(@{valor($ref,'listacom',$valor)},@listavalores);
              agregar_comentarios($ref,$cosa,@listacomvalor,' Eval '.__LINE__);
              aumentar_SUST($ref,$tipo,$cosa);
          };
      } else {
          impr_dat(__LINE__.' Eval principal final corto',$cosa,$ref,'cSS');
          next;
      };
      impr_dat(__LINE__.' Eval principal final largo',$cosa,$ref,'cSS'); 
  };#$cosa 
  impr_datos(__LINE__.' Eval',['TODOS'],$ref);
  impr_SUST(__LINE__.' Eval',$ref);
  push @posibles,@{$ref->{listaDINICIALES}} if $ref->{listaDINICIALES};
  push @posibles,@{$ref->{listaVIINICIALES}} if $ref->{listaVIINICIALES};
  push @posibles,@{$ref->{listaTABLAS}} if $ref->{listaTABLAS}; 
  push @posibles,@{$ref->{listaFUNCIONES}} if $ref->{listaFUNCIONES}; 
  my @receptoresori = grep(do {$ref->{TIPOTOK}->{$_} ne 'P' and
                               $ref->{TIPO}->{$_} and 
                           $ref->{TIPO}->{$_} !~ /[noSs]/},@posibles);
  my @receptores = grep (do{@{valor($ref,'REFARG',$_)}},@receptoresori);
  impr_debug(__LINE__.' Eval @receptores',\@receptores);
  my @cambiados;
  $coderr = sustituir_SUST($ref,@receptores);
#  my @newdadores = sort keys %{$ref->{SUSTnoSsadp}};
#  while (1== 0 and @newdadores) {
#      impr_debug(__LINE__.' Eval @newdadores',\@newdadores); 
#      my $susti = shift (@newdadores);
#      ($coderr,my @nuevos) = SUST_sustituir($ref,$susti);
#      impr_debug(__LINE__.' Eval @nuevos',\@nuevos); 
#      $coderr and last;
#      if ($ref->{TIPOTOK}->{$susti} eq 'p') {
#          $ref->{TIPOTOK}->{$susti} = 'P';
#          impr_dat(__LINE__.' Eval',$susti,$ref,'SSa');
#      };
#      if (@nuevos) {
#          push @newdadores,@nuevos;
#          impr_debug(__LINE__.' Eval @newdadores',\@newdadores);
#      }; 
#  };
  impr_datos(__LINE__.' Eval',['TODOS'],$ref); 
  comfin('finE crear_SUSTn_SUSTadp');
  return $coderr;
}#crear_SUSTn_SUSTadp;
# ---------------------------------------------------------------------------
sub evaluar_ques{#REVISAR
    impr_debug(__LINE__.' Eval','evaluar_ques ANULADO');return '';
  comfin('comE evaluar_ques REVISAR',@_);
  my ($ref,$reflistaque) = @_;my ($coderr,$mensaje) = ('','');
  foreach my $que (@$reflistaque) { 
      impr_datos(__LINE__.' Eval',[$que],$ref); 
      foreach my $cosa (@{$ref->{"lista$que"}}) {
	  my $cambio ='';
#	  next if $ref->{TIPOTOK}->{$cosa} eq 'P';
          my ($valor0,$tipo0,$tiparg0,$refarg0) = tomar_cua_datos($ref,$cosa);
          my ($valor,$tipo,$tiparg) = ('','',$tiparg0); 
          my $refarg = []; @$refarg = @$refarg0;
          impr_dat(__LINE__.' Eval',$cosa,$ref,'que');
          next if length($tiparg) <=2 or $tipo0 eq '0';
#          ($coderr,$cambio,$tiparg,$refarg)
#            = evaluar_tiparg_refarg($ref,$tiparg0,$refarg0,'Eval '.__LINE__);
#          next if not $coderr and not $cambio; 
          if (not $coderr) {
              impr_par(__LINE__.' Eval',$tiparg,$refarg);
              ($coderr,$valor,$tipo,$tiparg,$refarg)
               = tiparg_refarg_2_vttr_talcual($tiparg,$refarg,'Eval '.__LINE__);
          };
          if ($que ne 'PEDIDOS') {
              if (not $coderr) {
                  cargar_datos($ref,'',$cosa,$valor,$tipo,$tiparg,$refarg);
                  agregar_comentarios($ref,$cosa,$valor0,'Eval '.__LINE__);
  #                impr_dat(__LINE__.' Eval',$cosa,$ref,'equ');
                  $tipo =~ /[no]/ and 
                    $que =~/(DATOS|PPARAMETROS|DPARAMETROS)/ and
		    $ref->{SUSTno}->{$cosa} = 1;
              }  else {
                  $ref->{TIPO}->{$cosa} = '0';
                  agregar_comentarios($ref,$cosa,'error','Eval '.__LINE__);
              };
          }; 
      };#$cosa
  };#que
  impr_datos(__LINE__.' Eval',$reflistaque,$ref);
  comfin('finE evaluar_ques',$coderr,$mensaje);
  return $coderr,$mensaje;
}#evaluar_ques
# ---------------------------------------------------------------------------
sub evaluar_funcion{# devuelve $coderr,$valor,$tipo,$tiparg,$refarg
  #unico argumento de subrutina la variable de tipo funcion
  # solo argumentos para funcion numeros o expresiones numericas
  comfin('comE evaluar_funcion',@_);
  my ($ref,$cosa) = @_;
  my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$cosa);
  my ($coderr,$mensaje) = ('',''); 
  my ($tipofunc,$func,$tipargd,$refargd,$valord);
  if ($tiparg =~ /^(\w)\(([no,]+)\)$/) {
      $tipofunc = $1; $tipargd = $2; @$refargd = @$refarg;
      $func = shift @$refargd;
      $valord = tiparg_refarg_2_valor_talcual($tipargd,$refargd,__LINE__);
  } else {            
      mensajear(" No corresponde usar evaluar_funcion");
      comfin('finE evaluar_funcion',$coderr);
      return $coderr;
  };  
  my ($valore,$tipoe,$tiparge,$refarge); 
  if ($tipofunc eq 'g') {
      my ($coderr,$reflisargus)
        = tiparg_refarg_2_lisargus($func,$tiparg,$refarg);
      ($coderr,$mensaje,$valore,$tipoe,$tiparge,$refarge)
            = evaluar_g_n($func,$tiparg,$refarg); #en ev._func
  } elsif ($tipofunc eq 'q' and $ref->{TIPOTOK}->{$func} eq 'Q') { 
          ($coderr,$mensaje,$valore,$tipoe,$tiparge,$refarge)
              = evaluar_q_n($ref,$func,$tipargd,$refargd);#en ev.fun
  } elsif ($tipofunc eq 'f') {
      ($coderr,$mensaje,$valore,$tipoe,$tiparge,$refarge)
         = vttr(lc($func)."(lc($valord))");  #en evaluar_funcion
  } elsif ($tipofunc eq 't' and $ref->{TIPOTOK}->{$func} eq 'T') {
      ($coderr,$mensaje,$valore,$tipoe,$tiparge,$refarge)
         = evaluar_t_n($ref,$func,$valord);  #en evaluar_funcion
  } else {
      $coderr = 60; $mensaje = " No se entiende $func de tipo $tipofunc";
  };    
  if ($coderr) {
      mensajear($mensaje) if $mensaje;
      comfin('finE evaluar_funcion',$coderr,$mensaje);
      return $coderr;
  };
  comfin('finE evaluar_funcion',$coderr,$valore,$tipoe,$tiparge,'||',@$refarge);
  return $coderr,$valore,$tipoe,$tiparge,$refarge;  
}
# ---------------------------------------------------------------------------
sub evaluar_lista_numeros{#solo se usa si se cree que evaluara a numeros
  comfin('comE evaluar_lista_numeros',@_);
  my ($valor) = $_[0];my ($coderr,$mensaje);
  my @lista = split '\s*,\s*',$valor;
  ($coderr,@lista) = juntar_por_paren_cur(',',@lista);
  $coderr and return 33,$coderr;
  my ($newvalor,$newtiparg,$newrefarg) = ('','',[]);
  foreach my $parte (@lista) {
      ($coderr,$mensaje,my ($valorcito,$tipito,$tipargcito,$refargcito))
         = evaluar_numero($parte);
      if (not $coderr) {
          $newvalor .= ','.$valorcito; $newtiparg  .= ','.$tipargcito;
          push @$newrefarg,@$refargcito;
      } else {last};
  };
  if (not $coderr) {
      $newtiparg =~ s/^,//; $newvalor =~ s/^,//;
  };
  comfin('finE evaluar_lista_numeros',$coderr,$mensaje,$newvalor
          ,',',$newtiparg,$newrefarg);
  return $coderr,$mensaje,$newvalor,',',$newtiparg,$newrefarg;
}#evaluar_lista_numeros
# ---------------------------------------------------------------------------
sub evaluar_lista_cruda_numeros{#solo se usa si se cree que evaluara a numeros
  comfin('comE evaluar_lista_cruda_numeros',@_);
  my ($valor) = $_[0];my ($coderr,$mensaje);
  my @lista = split '\s*,\s*',$valor;
  ($coderr,@lista) = juntar_por_paren_cur(',',@lista);
  $coderr and return 33,$coderr;
  my ($newvalor,$newtiparg,$newrefarg) = ('','',[]);
  foreach my $parte (@lista) {
      ($coderr,$mensaje,my ($valorcito,$tipito,$tipargcito,$refargcito))
         = evaluar_numero(lc($parte));
      if (not $coderr) {
          $newvalor .= ','.$valorcito; $newtiparg  .= ','.$tipargcito;
          push @$newrefarg,@$refargcito;
      } else {last};
  };
  if (not $coderr) {
      $newtiparg =~ s/^,//; $newvalor =~ s/^,//;
  };
  comfin('finE evaluar_lista_cruda_numeros',$coderr,$mensaje,$newvalor
          ,',',$newtiparg,$newrefarg);
  return $coderr,$mensaje,$newvalor,',',$newtiparg,$newrefarg;
}#evaluar_lista_cruda_numeros
# ---------------------------------------------------------------------------
sub evaluar_tiparg_refarg{
  comfin('comE evaluar_tiparg_refarg',@_);
  #si aparecen funciones o tablas los argumentos son atomicos o lista de atom.
  my ($ref,$tiparg0,$refarg0,$mens_cla) = @_;
  my ($coderr,$mensaje,$cambio) = ('','','');
  if ($tiparg0 =~ /^[\WSs]*$/) {
      comfin('finE evaluar_tiparg_refarg',__LINE__,'',$coderr,$cambio
       ,$tiparg0,'||',@$refarg0);
      return $coderr,$cambio,$tiparg0,$refarg0,$mens_cla;
  };
  impr_par(__LINE__.' Eval 0',$tiparg0,$refarg0);
  my ($tiparg1,$tiparg2,$tiparg3) = ('','','');
  my ($refarg1,$refarg2,$refarg3) = ([],[],[]);
  (my $esqtiparg = $tiparg0) =~ tr/-+*\//    /;
  if ($esqtiparg =~ /^[ fno\(\)]+$/) {
      $cambio = 1;
      my $val = tiparg_refarg_2_valor_talcual(
        $tiparg0,$refarg0,'Eval '.__LINE__);
      ($coderr,$mensaje,my ($valor,$tipo,$tiparg3,$refarg3))
         = evaluar_numero($val);
      if ($coderr){
	  mensajear($mensaje); return $coderr;
      } else {
          comfin('finE evaluar_tiparg_refarg',__LINE__,$coderr,$cambio
             ,$tiparg3,'||',@$refarg3,$mens_cla);
          return $coderr,$cambio,$tiparg3,$refarg3,$mens_cla;
      };         
  };  
  $tiparg1 = ",$tiparg0,"; @$refarg1 = @$refarg0;
  ($esqtiparg = $tiparg1) =~ tr/-+*\//    /;
  impr_debug(__LINE__.' Eval $esqtiparg',$esqtiparg);
      
  if (($esqtiparg =~ /\(([ no]+)[\),]/ or $esqtiparg =~ /,([ no]+)[\),]/)  
      and length $1 > 2  ) {
      $cambio = 1;
      ($coderr,$tiparg1,$refarg1) = simpl_paren_numer($tiparg1,$refarg1);
      if ($coderr) {
          comfin('finE evaluar_tiparg_refarg linea $coderr',__LINE__,$coderr
           ,$mens_cla);
          return $coderr,$mens_cla;
      };
  };
  impr_par(__LINE__.' Eval 1 ',$tiparg1,$refarg1);
  (my $esqtiparg1 = $tiparg1) =~ tr/-+*\/,/     /;
  impr_debug(__LINE__.' Eval $esqtiparg1',$esqtiparg1);
  $tiparg2 = $tiparg1; @$refarg2 = @$refarg1;
  impr_par(__LINE__.' Eval',$tiparg2,$refarg2);           
  if ($tiparg2 =~ /\(o\)\*\*/ or $tiparg2 =~ /o\*\*/) {
      $coderr = 25;
      mensajear( 
	  "Potencia de base negativa: si es posible expresela con producto");
  };
  if (length($tiparg2) > 4 and $tiparg2 =~ /[no][\-\+].*[no]/) {
      $cambio = 1;
      $tiparg2 =~ s/,(.+),$/$1/;
      ($coderr,$tiparg3,$refarg3)
         = Simusol::Evaluaciones2::evaluar_terms($tiparg2,$refarg2);
  } else { 
      $tiparg3 = $tiparg2; @{$refarg3} = @{$refarg2};
  };
  $tiparg3 =~ s/^,(.+),$/$1/;
  impr_par(__LINE__.' Eval 0',$tiparg3,$refarg3);

  comfin('finE evaluar_tiparg_refarg',__LINE__,''
    ,$coderr,$cambio,$tiparg3,'||',@$refarg3,$mens_cla);
  return $coderr,$cambio,$tiparg3,$refarg3,$mens_cla;
}#evaluar_tiparg_refarg
# ---------------------------------------------------------------------------
sub gpr_gsu{ #revisa los usos de QPRODUCTO y QSUMA para ver cuales 
# funciones QP .. y QS definir y simplificar usos.
# los argumentos pueden ser atomicos,  o tabla
  comfin('comE gpr_gsu', @_);
  my ($ref,$circmod,@parsg)=@_; my ($coderr,$mensaje) = ('','');
  my @fung = ('QPRODUCTO','QSUMA');
  my $tipo = 'x';my $valor;

  foreach my $key (sort @parsg) {
      my ($vvalor, $tipo,$tiparg, $refarg) = tomar_cua_datos($ref,$key);
      my @refargd = @$refarg; my $func = shift @refargd; 
      (my $tipargd = $tiparg) =~ s/^g\((.+)\)/$1/;
      my ($coderr,$newtiparg,$newrefarg)
         = tiparg_refarg_2_lisargus($func,$tipargd,\@refargd);
      cargar_tiparg_refarg($ref,$key,$newtiparg,$newrefarg);
      agregar_comentarios($ref,$key,$vvalor,'Eva2 '.__LINE__);
  };# foreach  @gtipados
  impr_datos(__LINE__.' Eval',['FUNCIONES'],$ref);
  foreach my $key (sort @parsg) {
      my ($vvalor, $tipo,$tiparg, $refarg) = tomar_cua_datos($ref,$key);
      next unless $tipo eq 'g';
      my $cuantos = @$refarg - 1; my $func = $refarg->[0];my $ope = '*';
      $func eq 'QSUMA' and $ope = '+';
      my $nuevafunc = definir_gpr_gsu($ref,$cuantos,$ope);
      impr_debug(__LINE__.' Eval $nuevafunc',$nuevafunc);
      $refarg->[0] = $nuevafunc;
      $tiparg =~ s/^g/q/;
      cargar_tiparg_refarg($ref,$key,$tiparg,$refarg);
  };
  impr_datos(__LINE__.' Eval',['FUNCIONES'],$ref);
  comfin('finE gpr_gsu'); 
  return;
}#gpr_gsu
# ---------------------------------------------------------------------------
sub intentar_argu_h{
  comfin('comE intentar_argu_h',@_);
  my ($ref,$pre,$valor) = @_;
  my $tipotok = valor($ref,'TIPOTOK',$valor);
  if ($tipotok eq 's') {
      return $tipotok,[$valor];
  } else {
  };    
  comfin('finE intentar_argu_h',@_);
  return;
}#intentar_argu_h
# ---------------------------------------------------------------------------
sub intentar_tabla_con_1blanco{# el separador siguiente es (
  comfin('comE intentar_tabla_con_1blanco',@_);
  my($ref,$valorori) = @_; my ($coderr,$mensaje) = ('','');
  (my $valor = $valorori) =~ s/^(T)A{0,1}B{0,1}L{0,1}.* (\w+)$/T$2/i;
  impr_debug(__LINE__.' Eval $valorori,$valor',[$valorori,$valor]);
  if (lc(valor($ref,'TIPOTOK',$valor)) eq 't') {
      return $coderr,$mensaje,$valor;
  } else {
      $coderr = 30;
      $mensaje = (" No se entiende $valorori como una tabla"); 
      return $coderr,$mensaje;
  }; 
}#intentar_tabla_con_1blanco
# ---------------------------------------------------------------------------
sub intentar_token_con_1blanco{# el separador siguiente no es (
  comfin('comE intentar_token_con_1blanco',@_);my ($coderr,$mensaje) = ('','');
  my ($ref,$valor) = @_;
  my ($VI,$cosa) = ($valor =~ /^(\w+) (\w+)$/);
  my $tipotokcosa  = valor($ref,'TIPOTOK',$cosa);
  if ($tipotokcosa eq  'a') {
      if ($VI eq '' or $VI =~ /^[VI]$/i) {
          my $token = $VI.$cosa ; $token =~ s/^VE/E/;$token =~ s/^IJ/J/;
          return $coderr,$mensaje,$token;
      };
  } elsif ($tipotokcosa eq 'm' and $VI eq 'V') {
      my $marcacosa = "NODOCIRC";
      $ref->{clasearch} eq 'elementos' and $marcacosa = "NODOELEM" or
      return $coderr,$mensaje,$marcacosa.$cosa;     
  };
  $coderr = 35;
  $mensaje = " No se reconoce $valor";
  comfin('finE intentar_token_con_1blanco',$coderr,$mensaje);
  return $coderr,$mensaje;
}#intentar_token_con_1blanco
# ---------------------------------------------------------------------------
sub interpretar_h{
  comfin('comE interpretar_h',@_);
  my ($ref,$func,$VI,$cosa,$marcacosa,$tipotokcosa) = @_;my $coderr = '';
  impr_debug(__LINE__.' Eval $func',$func);
  my ($valor,$tipo,$tiparg,$refarg);
  if ($tipotokcosa eq 'a') {
      if ($cosa =~ /^E/ and $VI eq 'V'
            or $cosa eq 'J' and $VI eq 'I') {
          $valor = $cosa;
          $tipo = $tiparg = 'a'; 
      } else {
          $valor = "$VI$cosa";
          $tipo = $tiparg = 's'; 
      };
      $refarg = [$valor];
  } else {
      $marcacosa = "NODOCIRC"; 
      $ref->{clasearch} eq 'elementos' and $marcacosa = "NODOELEM" or
         $ref->{clasearch} eq 'modelo' and $marcacosa = "NODOMODELO";
      if ($marcacosa eq 'NODOCIRC') { 
          my $nvalor = "V$marcacosa$cosa";
          impr_dat(__LINE__.' Eval $nvalor',$nvalor,$ref,'i_h');
          ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$nvalor);
          impr_debug(__LINE__.' Eval $nvalor'
             ,[$nvalor,$valor,$tipo,$tiparg,'||',@$refarg]);
	  if ($valor !~ /\w/) {
              $valor = cerofuentear($ref,$cosa);
              $tipo = $tiparg = 's'; $refarg = [$valor];
           };  
      } else {
          $valor = "$VI($marcacosa$cosa)";
          $tipo = 'h'; $tiparg = "h($tipotokcosa)";
          $refarg = [$VI,"$marcacosa$cosa"];
      };
   }; 
   comfin('finE interpretar_h linea ',__LINE__,' '
         ,$coderr,$valor,$tipo,$tiparg,'||',@$refarg);
  return $coderr,$valor,$tipo,$tiparg,$refarg;
} #interprear_h
# ---------------------------------------------------------------------------
sub pegar{
  #para pegar dos $tiparg siendo cuidadosos con sintaxis
  #se supone que ambos pares son 'consistentes' 
  comfin('comE pegar',@_);

  my ($tiparg0,$tiparg1,$abre,$cierra,$refarg0,$refarg1) = @_;
  impr_debug (__LINE__.' Eval'
         ,[$tiparg0,'||',$tiparg1,'||',@$refarg0,'||',@$refarg1]); 
  my ($tiparg,$refarg) = ('',[]);
  if ($tiparg0 eq '') { #tambien $refarg0 sera vacio
      $tiparg = $tiparg1; @$refarg = @$refarg1;
  } elsif ($tiparg1 eq '') { #tambien sera $refarg1 vacio
      $tiparg = $tiparg0; @$refarg = @$refarg0;
  } else { # $tiparg0 ne '' and $tiparg1 ne ''
      my ($pre,$cosafinal0);
      my ($cosainicial1,$resto) = ('',$tiparg1);
      $tiparg1 =~ /^(.)(.*)$/ and do {$cosainicial1 = $1;$resto = $2};
      if ($cosainicial1 eq 'o') {
          $tiparg1 = '-' . 'n' . $resto;
          impr_debug(__LINE__.' Eval $refarg1',$refarg1);
          $refarg1->[0] = -$refarg1->[0];
          impr_debug (__LINE__.' Eval'
            ,[$tiparg0,'||',$tiparg1,'||',@$refarg0,'||',@$refarg1]); 
      };
      $tiparg1 =~ /^(.)(.*)$/ and do {$cosainicial1 = $1;$resto = $2};
      $tiparg0 =~ /^(.*)(.)$/ and do {$pre = $1; $cosafinal0 = $2};
      impr_debug(__LINE__.' Eval,$cosafinal0,$cosainicila1'
		 ,[$cosafinal0,'||',$cosainicial1]);
      if ($cosafinal0 =~ /\w/ and $cosainicial1 !~ /[\,\+\-\*\/\)]/ or
          $cosainicial1 =~ /\w/ and $cosafinal0 !~ /[\,\+\-\*\/\(]/) {
          error_progr(0,__LINE__.' Eval');
      };
      impr_par(__LINE__.' Eval  0',$tiparg0,$refarg0);
      impr_par(__LINE__.' Eval  1',$tiparg1,$refarg1);
       if ($cosainicial1 eq '-') {
          if ($cosafinal0 =~ /[\w\(\[\)\]]/) {
	  } elsif ($cosafinal0 =~ /[\*\/]/) {
              $tiparg1 = $abre . $tiparg1 . $cierra;
          } elsif ($cosafinal0 eq '+') {
              $tiparg0 =~ s/.$//;
          } elsif ($cosafinal0 eq '-') {
              $tiparg0 =~ s/.$/+/;
              $tiparg1 =~ s/^.//;
          };
      };
      impr_debug (__LINE__.' Eval'
         ,[$tiparg0,$tiparg1,'||',@$refarg0,'||',@$refarg1]); 
      $tiparg = $tiparg0 .$tiparg1;
      @$refarg = (@$refarg0,@$refarg1);
  };
  comfin('finE pegar',$tiparg,'||',@$refarg,'||');
  return $tiparg,$refarg;
}#pegar
# ---------------------------------------------------------------------------
sub pegar3{
  # el valor debe estar correctamente escrito; y tambien hay que cuidar
  # la relacion entre tiparg y refarg
  comfin('comE pegar3',@_);
  my ($tiparg0,$tiparg1,$tiparg2,$refarg0,$refarg1,$refarg2,$abre,$cierra
      ,$valor0,$valor1,$valor2) = (@_,'','','');
  my ($tiparg,$refarg,$valor);
#  $valor = $valor0 . $valor1 . $valor2; 
  if ($tiparg1 eq 'n' and ($tiparg0 =~ /[\(,]\-$/ or $tiparg0 =~ /^\-$/)) {
        #cambia n por o
      ($tiparg = $tiparg0) =~ s/\-$/o$tiparg2/;
      @$refarg = (@$refarg0,-$refarg1->[0],@$refarg2);
      comfin('finE pegar3 ',__LINE__,' ||',$tiparg,'||',@$refarg,'ccc',$valor);
      return $tiparg,$refarg,$valor;
  } elsif ($tiparg1  eq 'o'and ($tiparg0 =~ /[\(,]\-$/ or $tiparg0 =~ /^\-/)) {
      #cambia o por n
      ($tiparg = $tiparg0) =~ s/\-$/n$tiparg2/;
      @$refarg = (@$refarg0,-$refarg1->[0],@$refarg2);
      comfin('finE pegar3 ',__LINE__,' ||',$tiparg,'||',@$refarg,'ccc',$valor);
      return $tiparg,$refarg,$valor;
  } elsif (length $tiparg1 == 1) {# ya se separo algun n y o; 
  };
  if ($tiparg1 =~ /^o/) {
      if ($tiparg0 =~ /[\(,]$/ or $tiparg0 eq '') {
      } else {
          $tiparg1 =~ s/^o/-n/;
          $refarg1->[0] = - $refarg1->[0]; 
          impr_debug(__LINE__.' Eval $tiparg0,$tiparg1,$tiparg2'
		 ,[$tiparg0,'||',$tiparg1,'||',$tiparg2]);
          impr_debug(__LINE__.' Eval $refarg0,$refarg1,$refarg2'
		 ,[@$refarg0,'||',@$refarg1,'||',@$refarg2]);
      };
  };
  if (length $tiparg1 == 2) {# esto es -\w
      if ($tiparg0 =~ /\($/ and $tiparg2 =~ /^\)/) {
          $tiparg0 =~s/\($/$abre/;$tiparg2 =~ s/^\)/$cierra/;
      } elsif ($tiparg0 =~/[\*\/]$/ or $tiparg2 =~ /^[\*\/]/) {
          $tiparg1 = $abre . $tiparg1 . $cierra;
      } elsif ($tiparg0 =~ /\+$/ and (
               $tiparg2 =~/^[\+\-\),]/ or $tiparg2 eq '')) {
          $tiparg0 =~ s/\+$/-/; $tiparg1 =~s/\-//; 
      } elsif ($tiparg0 =~ /\-$/ and (
               $tiparg2 =~/^[\+\-\),]/ or $tiparg2 eq '')) {
          $tiparg0 =~s/\-/+/; $tiparg1 =~s/\-//; 
      };
  } elsif ($tiparg1 =~ /^\w\(([^\(\)]+)\)$/) {
  } elsif (length ($tiparg1) > 2) { 
      if ($tiparg0 =~ /\($/ and $tiparg2 =~ /^\)/) {
          $tiparg0 =~s/\($/$abre/;$tiparg2 =~ s/^\)/$cierra/;
      } elsif ($tiparg0 =~ /[\(,]$/ and $tiparg2 =~ /^\),/) {
          #ambos parentesis ya esta tratado
      } else {
          $tiparg1 = $abre . $tiparg1 . $cierra;
      };
  }; 
  $tiparg = $tiparg0 . $tiparg1 . $tiparg2;
  $tiparg  =~ s/\+\+/+/g; $tiparg =~s/\+\-/-/g;
  @$refarg = (@$refarg0,@$refarg1,@$refarg2);
  comfin('finE pegar3 ',__LINE__,' ||',$tiparg,'||',@$refarg,'ccc',$valor);
  return $tiparg,$refarg,$valor;
} #pegar3
# ---------------------------------------------------------------------------
sub pegarmasmenos{
  my $tiparg = $_[0];
  while ($tiparg =~ s/\+\-/-/  or  $tiparg =~ s/\-\+/-/ or
         $tiparg =~ s/\+\+/+/ or  $tiparg =~ s/\-\-/+/) {};
  return $tiparg;
}
# ---------------------------------------------------------------------------
sub simpl_com_func{# la expresion comienza con $func y los argumentos son num. 
  comfin('comE simpl_com_func',@_);
  my ($ref,$func,$tipfunc,$tipargu,$refargu) = @_;
  my $valorc =tiparg_refarg_2_valor_talcual($tipargu,$refargu,'Eval '.__LINE__);
  my ($coderr,$mensaje) = ('','');
  my $valor;
  if ($tipfunc eq 'f') {
      ($coderr,$mensaje,$valor)
        = evaluar_numero(lc($func).'('.$valorc.')');
  } elsif ($tipfunc eq 'q' and $ref->{TIPOTOK}->{$func} eq 'Q') {
      ($coderr,$mensaje,$valor) = evaluar_q_n($ref,$func,$tipargu,$refargu);
  } elsif ($tipfunc eq 'g') {
      ($coderr,$mensaje,$valor) = evaluar_G_n($func,$tipargu,$refargu);# MAL
  } elsif ($tipfunc eq 't' and $ref->{TIPOTOK}->{$func} eq 'T') {
      if ($tipargu !~ /,/) {
          ($coderr,$mensaje,$valor) = evaluar_t_n($ref,$func,$valorc);
      } else {
          $coderr = 33; $mensaje = " Las tablas solo admiten un argumento";
      };    
  };
  my ($tipargvalor,$refargvalor) = ('',[]);
  if (not $coderr) {
      if (not defined $valor) {
          $coderr = 1;
      } else {
	  $refargvalor = [abs($valor)];
	  $tipargvalor = 'n'; $valor < 0 and $tipargvalor = 'o';
      }
  };
  comfin('finE simpl_com_func',$tipargvalor,'||',@$refargvalor);
  return $coderr,$mensaje,$tipargvalor,$refargvalor;     
}#simpl_com_func';
# ---------------------------------------------------------------------------
sub simpl_paren_func{
  comfin('comE simpl_paren_func',@_);
  my($ref,$tiparg,$refarg) = @_; my ($coderr,$mensaje) = ('',''); 
  impr_par(__LINE__.' Eval ',$tiparg,$refarg);
  while ($tiparg =~ /^(.*)([fgqt])\((-{0,1}[no][-,no]*)\)(.*)$/ ) {
     impr_debug(__LINE__.' Eval $1 $2 $3 $4 ',[$1,'||',$2,'||',$3,'||',$4]);
      my ($tipargantes,$tipfunc,$tipargd,$tipargdespues) = ($1,$2,$3,$4);
      my $tiparg0 = "$tipargantes$tipfunc("; my $tiparg2 = ")$tipargdespues";
      my ($refarg0,$refargd,$refarg2)
        = partir_refarg($refarg,$tiparg0,$tipargd,$tiparg2);
      impr_par(__LINE__.' Eval ', $tiparg0,$refarg0);
      impr_par(__LINE__.' Eval ', $tipargd,$refargd);
      impr_par(__LINE__.' Eval ', $tiparg2,$refarg2);
      my $func = $refarg0->[-1];
      my ($crudo,$valor,$tipito,$tipargcito,$refargcito);
      impr_debug(__LINE__.' Eval $func,$tipfunc,$tipargd'
       , [$func,$tipfunc,$tipargd]); 
     if ($tipfunc eq 'f') {
          $valor = tiparg_refarg_2_valor_talcual(
            $tipargd,$refargd,'Eval '.__LINE__);
          ($coderr,$valor)
            = evaluar_numero(lc($func).'('.$valor.')');
      } elsif ($tipfunc eq 'q' and $ref->{TIPOTOK}->{$func} eq 'Q') {
          ($coderr,$crudo) = evaluar_q_n($ref,$func,$tipargd,$refargd);
      } elsif ($tipfunc eq 'g') {
          ($coderr,$valor) = evaluar_G_n($func,$tipargd,$refargd);#MAL
      } elsif ($tipfunc eq 't' and $ref->{TIPOTOK}->{$func} eq 'T') {
         $valor = tiparg_refarg_2_valor_talcual(
           $tipargd,$refargd,'Eval '.__LINE__);
         ($coderr,$valor) = evaluar_t_n($ref,$func,$valor);
      } else {
          $coderr = 33;
      };
      impr_debug(__LINE__.' Eval $coderr,$crudo,$valor'
        ,[$coderr,$crudo,$valor]);
      if (defined $crudo) {
          ($coderr,$valor,$tipito,$tipargcito,$refargcito)
         = evaluar_numero($crudo);
      };
      if (not $coderr and defined $valor) {
          $refargcito = [abs($valor)];
          my ($refargantes,$refargdespues) = ($refarg0,$refarg2);
          pop @$refargantes;
          impr_par(__LINE__.' Eval',$tipargantes,$refargantes);
          impr_par(__LINE__.' Eval',$tipargcito,$refargcito);
          impr_par(__LINE__.' Eval',$tipargdespues,$refargdespues);
          @$refarg = (@$refargantes,@$refargcito,@$refargdespues);
          if ($valor >= 0) {
              $tiparg = $tipargantes .'n'.$tipargdespues;
          } else {
              $tiparg = $tipargantes .'o'.$tipargdespues;
          };
          #no le pongo parent. al 'o' porque esta bien delimitado por () o ,
      } else {
          $tiparg = $tipargantes.$tipfunc.'['.$tipargd.']'.$tipargdespues;
          $coderr = '';
      };
  };
  $tiparg = simplificar_tiparg($tiparg) if length($tiparg) > 1;
  impr_par(__LINE__.' Eval', $tiparg, $refarg);         
  comfin('finE simpl_paren_func',$coderr,$tiparg,'||',@$refarg);
  return $coderr,$tiparg,$refarg;
}#simpl_paren_func
# ----------------------------------------------------------------------------
sub simplificar_valores{# se usa para TIEMPOS
  comfin('comE simplificar_valores',@_);
  my($ref,$refque,$refdadores) = @_; my $coderr = '';
  my (@receptores,@dadores);
  impr_datos(__LINE__.' Eval',['PARAMETROS'],$ref);
  foreach my $que (@{$refque}) {
      push @receptores,@{$ref->{"lista$que"}} if $ref->{"lista$que"};
      push @receptores,@{$ref->{"listaparametros$que"}} 
        if $ref->{"listaparametros$que"};
      push @receptores,@{$ref->{"listaR$que"}} if $ref->{"listaR$que"};
  };
  my @aborrar; #contendra los parametros de "listaparametros$que" innecesarios
  impr_datos(__LINE__.' Eval',$refque,$ref);
  impr_debug(__LINE__.' Eval @receptores',\@receptores);
#  @receptores = grep (do{not $ref->{TIPO}->{$_} =~ /[anopSs]/},@receptores); 
  @receptores = grep ( do{$ref->{TIPARG}->{$_} =~ /[apd]/},@receptores);
  impr_debug(__LINE__.' Eval @receptores',\@receptores);
  if (not @receptores) {
      comfin('finE simplificar_valores');
      return '';
  };
  if (defined $refdadores) {
     @dadores = @$refdadores;
  } else {
     push @dadores, @{$ref->{listaDATOS}}
       if defined $ref->{listaDATOS};
     push @dadores, @{$ref->{listaPPARAMETROS}}
       if defined $ref->{listaPPARAMETROS};
     push @dadores, @{$ref->{listaDPARAMETROS}}
       if defined $ref->{listaDPARAMETROS};
  };  
  impr_debug(__LINE__.' Eval @dadores',\@dadores);
  impr_datos(__LINE__.' Eval',['TODOS'],$ref);
  my (%valorsust,%tiposust,%tipargsust,%refargsust);
  foreach (@dadores) {
      next unless $ref->{TIPOTOK}->{$_} =~ /[ap]/;
      my ($valsust,$tipsust,$tipasust,$refasust) 
	  = tomar_cua_datos($ref,$_);
      if ($tipsust =~ /[afghnopqtsS]/ or $tipsust eq 'x' and @$refasust == 1) {
          ($valorsust{$_},$tiposust{$_},$tipargsust{$_},$refargsust{$_})
	      = ($valsust,$tipsust,$tipasust,$refasust);
	  impr_dat(__LINE__.' Eval',$_,$ref,'std');
      };
  };
  @dadores = sort keys %refargsust;
  impr_debug(__LINE__.' Eval @dadores,keys %refargsust',[keys %refargsust]);
  impr_campo(__LINE__.' Eval $ref',$ref,'que'); 
  while (@receptores and @dadores) {
      my @recep = @receptores;
      @dadores = ();
      foreach my $rec (@recep) {
          my @tokens = grep (defined $refargsust{$_}
           ,@{$ref->{REFARG}->{$rec}});
          next unless @tokens;
          impr_dat(__LINE__.' Eval',$rec,$ref,'str');
          my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$rec);
          my @listatokens = @{$ref->{REFARG}->{$rec}};
          my ($nuevalor,$nuetipo,$nuetiparg,$nuerefarg) = ('','','',[]);
          while (@listatokens) {
              my $token = shift @listatokens;
              $tiparg =~ s/^(\W*)(\w)//; my ($pre,$tipito) = ($1,$2);
              my $tiparg0 = $pre; my $refarg0 = [];         
              my $tiparg1 = $tipito; my $refarg1 = [$token];
              my $tipargt = "$tiparg0$tiparg1"; my $refargt = [$token];
              impr_debug(__LINE__.' Eval el 0: ',"$tiparg0 || @$refarg0");
              impr_debug(__LINE__.' Eval el 1: ',"$tiparg1 || @$refarg1");
              if (defined $refargsust{$token}) {
                  $tiparg1
                    = "$tipargsust{$token}"; $refarg1 = $refargsust{$token};
                  ($tipargt,$refargt)
                    = pegar($tiparg0,$tiparg1,'(',')',$refarg0,$refarg1);     
              };
              impr_debug(__LINE__.' Eval el pegado: ',"$tipargt || @$refargt");
              $nuetiparg .= $tipargt; push @$nuerefarg, @$refargt;
              impr_debug(__LINE__.' Eval se forma: '
                ,"$nuetiparg || @$nuerefarg");
          };      
          $nuetiparg .= $tiparg;
          impr_par(__LINE__.' Eval ya se formo: ',$nuetiparg,$nuerefarg);
          my $cambio = ''; 
          if (length $nuetiparg > 2) {
              ($coderr,$cambio,$nuetiparg,$nuerefarg) = evaluar_tiparg_refarg(
                  $ref,$nuetiparg,$nuerefarg,'Eval '.__LINE__);
              if ($coderr) {
                   $rec = undef; next;
              };
          };
          if (length $nuetiparg > 2) {
              ($coderr,$nuevalor,$nuetipo,$nuetiparg,$nuerefarg)
         = tiparg_refarg_2_vttr_talcual($nuetiparg,$nuerefarg,'Eval '.__LINE__);
              impr_par(__LINE__.' Eval ya se formo: ',$nuetiparg,$nuerefarg);
          } elsif (length $nuetiparg == 2) {
              $nuetipo = 'x'; $nuevalor = -$nuerefarg->[0];
          } else {#length igual 1
              $nuetipo = $nuetiparg; $nuevalor = $nuerefarg->[0];
              $nuetipo eq 'o' and $nuevalor = -$nuevalor;
          };
          if (not defined $refdadores and $nuetipo =~ /[no]/) {
              ($valorsust{$rec},$tiposust{$rec},$tipargsust{$rec}
                ,$refargsust{$rec})
                 = ($nuevalor,$nuetipo,$nuetiparg,$nuerefarg);
              push @dadores,$rec;
              @receptores = grep ($_ ne $rec,@receptores);
              push @aborrar, $rec; #se controlara ... listaparametros$que
          };
          impr_debug(__LINE__.' Eval $valor,$nuevalor',$valor,$nuevalor);
          if ($valor ne $nuevalor and @aborrar == 0) {
              cargar_datos($ref,'',$rec,$nuevalor,$nuetipo,$nuetiparg
               ,$nuerefarg);
              impr_dat(__LINE__.' Eval',$rec,$ref,'str');
              agregar_comentarios($ref,$rec,$valor,'Eval '.__LINE__);
              impr_dat(__LINE__.' Eval',$rec,$ref,'str');
          }; 
      };
      impr_debug(__LINE__.' Eval @dadores',\@dadores);
  };
  impr_debug(__LINE__.' Eval @aborrar',\@aborrar);
  foreach my $rec (@aborrar) {
      my $que = $ref->{que}->{$rec};$que =~ s/^parametros//;
      impr_debug(__LINE__.' Eval $que,$rec',[$que,$rec]);
      if ($rec =~ /^P$que/) {
          borrar_datos($ref,"parametros$que",$rec,__LINE__.' Eval');
      }; 
  };
  impr_datos(__LINE__.' Eval',['TODOS'],$ref);
  comfin('finE simplificar_valores');
  return '';
}#simplificar_valores
# ---------------------------------------------------------------------------
sub sust_tokear{
  comfin('comE sust_tokear',@_);
  my ($ref,$refreceptores,$refsust) = @_; my $coderr= '';
  my @receptores = @$refreceptores; my @sust = @$refsust;
  my @nuevossust;
  foreach my $receptor (@receptores) {
      impr_dat(__LINE__.' Eval',$receptor,$ref,'rrr');
      my ($tipotok,$valor,$tipo,$tiparg,$refarg) = tomar_todo_datos(
       $ref,$receptor);
      my $valorori = $valor;
      next unless ($tiparg =~ /[adp]/);
      foreach my $token (@sust) {
          next unless grep (do{$_ eq $token},@$refarg);
          impr_dat(__LINE__.' Eval',$token,$ref,'ttt');
          my ($valortoken,$tiptoken,$tipargcito,$refargcito)
              = tomar_cua_datos($ref,$token);
          if ($valor eq $token) {
              $valor = $valortoken; $tipo = $tiptoken;
              cargar_datos($ref,'',$receptor,$valor,$tipo,$tipargcito
                 ,$refargcito);
              agregar_comentarios($ref,$receptor,$token,'Eval '.__LINE__);
              impr_dat(__LINE__.' Eval',$receptor,$ref,'rrr');
          } else {
              my @vtr;
              (@vtr) = sust_token($ref
                ,$receptor,$valor,$tiparg,$refarg #en sust_tokear
                ,$token,$valortoken,$tipargcito,$refargcito);
	      ($valor,$tiparg,$refarg) = @vtr;
	  };
          if ($valor ne $valorori) {
              impr_dat(__LINE__.' Eval',$receptor,$ref,'rrr');
              agregar_comentarios($ref,$receptor,$valorori,'Eval '.__LINE__);
              impr_dat(__LINE__.' Eval',$receptor,$ref,'rrr');
          };   
      };#$token
      if ($tipotok =~ /^[ap]$/ and $tipo =~ /^[anopsSW]$/) {
          push @nuevossust,$receptor;
      };   
  };
  comfin('finE sust_tokear',$coderr,@nuevossust);
  return $coderr,\@nuevossust;
}#sust_tokear
# ---------------------------------------------------------------------------
sub sust_token{
  # la responsabilidad de que la sustitucion sea util es del que llama
  # tampoco evalua tipo
  comfin('comE sust_token REVISAR',@_);
  my $coderr = '';
  my($ref,$receptor,$valor,$tiparg,$refarg
     ,$token,$valortoken,$tipargtoken,$refargtoken) = @_;
#  $tiparg =~ s/o/-n/g;
  impr_debug(__LINE__.' Eval $tiparg',$tiparg);
  my @vars = @$refarg;my ($newvalor,$newtiparg,$newrefarg) = ('','',[]);
  while (@vars) {
     my  $var = shift @vars;
      $tiparg =~ s/^(\W*)(\w)//;
      if ($var eq $token) {
          if($1 eq '' and length($tiparg) == 1) {
              $newtiparg = $tipargtoken;
          } else {
              $newtiparg .= $1."($tipargtoken)";
          };
          push @$newrefarg,@$refargtoken;
      } else {
          $newtiparg .= $1.$2;
          push @$newrefarg,$var
      };
      impr_debug(__LINE__.' Eval '
       ,[$newtiparg,'||',@$newrefarg]);
  };#@vars
  $newtiparg .= $tiparg;
  $newtiparg = simplificar_tiparg($newtiparg);
  $newvalor = tiparg_refarg_2_valor_talcual(
    $newtiparg,$newrefarg,'Eval '.__LINE__);
  $ref->{TIPARG}->{$receptor} = $newtiparg;
  $ref->{VALOR}->{$receptor} = $newvalor;
  @{$ref->{REFARG}->{$receptor}} = @$newrefarg;
  impr_dat(__LINE__.' Eval',$receptor,$ref,'st');
  comfin('finE sust_token',$newvalor,$newtiparg,@$newrefarg);
  return $coderr,$newvalor,$newtiparg,$newrefarg;
}#sust_token
# ---------------------------------------------------------------------------
sub sust_token_SUST{
  # la responsabilidad de que la sustitucion sea util es del que llama
  #  en %{$ref->{$sust}} estan los que se sustituiran
  comfin('comE sust_token_SUST',@_);
  my($ref,$cosa,$sust) = @_;my ($coderr,$cambiado) = ('','');
  my ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$cosa);
  impr_par(__LINE__.' Eval',$tiparg,$refarg);
  my @tokens = @$refarg;
  impr_debug(__LINE__.' Eval @tokens',\@tokens);
  impr_debug(__LINE__.' Eval $ref->{$sust}',Dumper $ref->{$sust});
  my ($vievalor,$newvalor,$newtipo,$newtiparg,$newrefarg);
  $vievalor = $valor;
  impr_debug(__LINE__.' Eval $vievalor',$vievalor);
  if (grep (do {$ref->{$sust}->{$_}},@tokens) ) { 
      ($newvalor,$newtipo,$newtiparg,$newrefarg) = ('',$tipo,'',[]);
      while (@tokens) {
          my  $token = shift @tokens;
          impr_debug(__LINE__.' Eval $token',$token);
          impr_debug(__LINE__.' Eval $tiparg',$tiparg);
          $tiparg =~ s/^(\W*)(\w)//; my ($pre,$tipito) = ($1,$2);
          if ($ref->{$sust}->{$token}) {
              impr_debug(__LINE__.' Eval',"habra cambio");
              if (valor($ref,'TIPOTOK',$token) !~ /[Ssfgkqt]/) {
                  impr_dat(__LINE__.' Eval',$token,$ref,'stS');
                  my ($valortoken,$tiptoken,$tipargtoken,$refargtoken)
                    = tomar_cua_datos($ref,$token);
                  impr_par(__LINE__.' Eval '.$token,$tipargtoken,$refargtoken);
                  if ($tiptoken eq 'o' and $tipo ne ','
                      or $tipo eq 'x' and $tiptoken ne 'f') {
                      # si el tipo es , todas las partes seran tokens
#                      $valortoken = '(' . $valortoken . ')';
                      $tipargtoken = '(' . $tipargtoken . ')'; 
                  }; 
                  $newtiparg .= $pre . $tipargtoken;
#                  $newvalor .= $pre . $valortoken;
                  push @$newrefarg,@$refargtoken;
                  $cambiado = 1;
                  impr_par(__LINE__.' Eval',$newtiparg,$newrefarg);
              } else {
                  $newtiparg .= $pre . $tipito;
#                  $newvalor .= $pre . $token;
                  push @$newrefarg,$token;
                  impr_par(__LINE__.' Eval',$newtiparg,$newrefarg);
              };
          } else {
              $newtiparg .= $pre . $tipito;
#              $newvalor .= $pre . $token;
              push @$newrefarg,$token;
              impr_par(__LINE__.' Eval',$newtiparg,$newrefarg);
          };
      };#while
      $newtiparg .= $tiparg;
      impr_debug(__LINE__.' Eval $cosa,$cambiado',[$cosa,$cambiado]);
      impr_par(__LINE__.' Eval',$newtiparg,$newrefarg);
      $newtiparg = simplificar_tiparg($newtiparg);
      if ($cambiado) {
          if ($newtiparg =~ /^[-+*\/nof]+$/) {
              ($coderr,$newtiparg,$newrefarg)
              = Simusol::Evaluaciones2::evaluar_tiparg_refarg_numerico(
                $newtiparg,$newrefarg);
               if ($coderr) {
                   mensajear(" No se pudo evaluar para $cosa");
               } else {
                   $tipo = $newtiparg;$newvalor = $newrefarg->[0];
                   $tipo eq 'o' and $newvalor = -$newvalor;
               };
	  } else {
	      $newvalor = tiparg_refarg_2_valor_talcual($newtiparg,$newrefarg);
          };
          cargar_datos($ref,'',$cosa,$newvalor,$tipo,$newtiparg,$newrefarg);
#	  agregar_comentarios($ref,$cosa,$vievalor,__LINE__.' Eval');
          impr_dat(__LINE__.' Eval',$cosa,$ref,'ctr'); 
          if (length $tiparg >1) {
              ($coderr,my ($tiparge,$refarge))
                 = mejorar_tiparg_refarg('',$tiparg,$refarg);
              if (not $coderr) {
                   impr_par(__LINE__.' Eval',$tiparg,$refarge); 
                   ($coderr,$newvalor,$newtipo,$newtiparg,$newrefarg)
                     = tiparg_refarg_2_vttr_talcual($tiparg,$refarge
                     ,'Eval '.__LINE__);
		   if ($tiparg ne $newtiparg) {
                       cargar_datos($ref,'',$cosa,$newvalor,$newtipo
                         ,$newtiparg,$newrefarg);  
                       agregar_comentarios($ref,$cosa,$valor,'Eval '.__LINE__)
                   };
              };
          };
      };# if $cambiado
  };#if
  comfin('finE sust_token_SUST',$coderr,$cambiado);
  return $coderr,$cambiado;
}#sust_token_SUST
# ---------------------------------------------------------------------------
sub sust_token_token{#cambia nombre de un token por otro dado por
# $tiparg y $refarg; este con un solo elemento
# responsabilidad de quien lo usa
  comfin('comE sust_token_token',@_); return;
  my ($ref,$cosa,$master,$tipargmaster,$refargmaster)= @_;
  my ($tok,$tipo);
  if (@$refargmaster == 1) {
      ($tok,$tipo) = ($refargmaster->[0],$tipargmaster);
  } else {
      ($tok,$tipo) = ($master,'p');
  };
  my @deps = keys %{$ref->{REFARG}};
  foreach my $dep (@deps) {
      impr_dat(__LINE__.' Eval',$dep,$ref,'dad');
      my ($tiparg,$refarg) = tomar_tiparg_refarg($ref,$dep); #NONO
      my @tokens = @$refarg; my $cambio = '';
      map(do{$_ eq $cosa and do{$_ = $tok; $cambio = 1}},@tokens);
      if ($cambio) {
          my $valor = $ref->{VALOR}->{$dep}; 
          @{$ref->{REFARG}->{$dep}} = @tokens;
          $ref->{VALOR}->{$dep} = tiparg_refarg_2_valor_talcual
            ($tiparg,$ref->{REFARG}->{$dep});
	  $ref->{com}->{$dep} = $valor; 
          $ref->{listacom}->{$dep} = [$valor]; 
          impr_dat(__LINE__.' Eval',$dep,$ref,'dad');
      };    
  };#$dep
  $ref->{TIPOTOK}->{$cosa} = 'P';
  $ref->{TIPO}->{$cosa} = $ref->{TIPARG}->{$cosa} = 'p';
  $ref->{VALOR}->{$cosa} = $master;
  $ref->{REFARG}->{$cosa} = [$master];    
  comfin('finE sust_token_token'); 
}#sust_token_token 
# ---------------------------------------------------------------------------
sub sustituir_SUST{
  comfin('comE sustituir_SUST',@_);
  my ($ref,@receptores) = @_;my $coderr = '';
  impr_SUST(__LINE__.' Eval',$ref); 
  my $nocambio; $ref->{cambio} = {};
  my $sust = 'SUSTnoSsadp';
  until ($nocambio) {
      $nocambio = 1;
      @receptores = grep(do{$ref->{TIPO}->{$_}
                            and $ref->{TIPO}->{$_} !~ /[noSsw]/},@receptores); 
      # el $ref->{SUSTnoSsadp} puede ir creciendo y @receptores disminuyendo
      impr_debug(__LINE__.' Eval @receptores',\@receptores);
      foreach my $cosa (@receptores) {
          impr_dat(__LINE__.' Eval',$cosa,$ref,'sS');
          ($coderr,my $cambiado)
            = sust_token_SUST($ref,$cosa,$sust);
          $coderr and last;
          if ($cambiado) {
	      my $tipo = $ref->{TIPO}->{$cosa};
              if ($tipo =~ /[noSsadp]/) {
	          aumentar_SUST($ref,$tipo,$cosa);
              };
              $nocambio = '';
          };
      };#foreach
      impr_debug(__LINE__.' Eval',[$nocambio,'Termine una vuelta']);
  }#until $nocambio;
  impr_SUST(__LINE__.' Eval',$ref);
  impr_datos(__LINE__.' Eval',['TODOS'],$ref);
  comfin('finE sustituir_SUST',$coderr);
  return $coderr;
}#sustituir_SUST
# ---------------------------------------------------------------------------
sub tiparg_refarg_nolista_2_vttr{
  comfin('comE tiparg_refarg_nolista_2_vttr',@_);
  my ($tiparg,$refarg) = @_; my $coderr = '';
  my ($valor,$tipo) = ('',''); 
  impr_debug(__LINE__.' Eval $tipo',$tipo);
  while (bien_cerrado($tiparg)) {$tiparg =~s/^\((.+)\)$/$1/}; 
  if (length $tiparg == 1) {
      $valor = $refarg->[0]; $tipo = $tiparg;
  } elsif ($tiparg =~ /^\-(\w)$/) {#length $tiparg == 2
       $valor = '-' . $refarg->[0]; my $posttipo = $1;
       $posttipo eq 'n' and $tipo = 'o' or $tipo = 'x';
  } else {
      $valor = tiparg_refarg_2_valor_talcual($tiparg,$refarg,'Eval '.__LINE__);
      if ((my $parent = $tiparg) =~ s/^(\w)\(/(/) {
          $tipo = $1; 
          my ($out1,$out2,$error) = cerrar_paren($parent);
          $error and do {$coderr = 66; return $coderr};
          if ($out2 ne '') {
              $tipo = 'x';
          };
      } else {
          $tipo = 'x';
      };
  }; 
  impr_debug(__LINE__.' Eval $tipo',$tipo);
  comfin('finE tiparg_refarg_nolista_2_vttr'
     ,$coderr,$valor,$tipo,$tiparg,@$refarg);
  return $coderr,$valor,$tipo,$tiparg,$refarg;
}#tiparg_refarg_nolista_2_vttr
# ---------------------------------------------------------------------------
sub tiparg_refarg_listatoken_2_valor_talcual{
  comfin('comE tiparg_refarg_listatoken_2_valor_talcual',@_);
  my ($tiparg,$refarg) = @_; my $coderr = '';
  my @refarg = @$refarg; 
  my @listiparg = split ',',$tiparg;
  my $valor = '';
  while (@refarg) {
      my $token = shift @refarg; my $tiptoken = shift @listiparg;
      $tiptoken eq 'o' and $valor .= ',-' . $token or
        $valor .= ',' . $token;
  }; 
  comfin('finE tiparg_refarg_listatoken_2_valor_talcual',$coderr,$valor);
  return $coderr,$valor;
}#tiparg_refarg_listatoken_2_valor_talcual

# ---------------------------------------------------------------------------
sub token_2_tipotok{
#llegan tokens de los que aun no se ha decidido cual es su tipotok
  comfin('comE token_2_tipotok',@_);
  my ($ref,$nombre) = @_; my $tipotok = 'w';my $coderr = '';
  my ($letra,$resto) = ($nombre =~/^(.)(.*)$/);
  (my $nombresinblanco = $nombre) =~ s/\s//;
  impr_debug(__LINE__.' Eval $nombre $nombresinblanco '
           ,[$nombre,$nombresinblanco]);
  if ($nombre =~ /^[\+\-\.\d]/) {
      my $nombres = $nombre; 
       ($coderr,$nombres,$tipotok) = evaluar_numero_SR($nombres,1);
      if ($coderr) { 
	  mensajear("Parecía número, pero no: $nombre");
      };
      impr_debug(__LINE__.' Eval $nombres,$tipotok',[$nombres,$tipotok]); 
      $nombre = $nombres;
  } elsif ($ref->{TIPOTOK}->{$nombresinblanco}) {
      $nombre = $ref->{VALOR}->{$nombresinblanco};
      $tipotok = $ref->{TIPO}->{$nombresinblanco};
  } elsif (defined $ref->{listanodos} and @{$ref->{listanodos}}) {
      print STDERR __LINE__." Eval loli paso por aqui\n";
      impr_debug(__LINE__.' Eval $ref->{listanodos}',$ref->{listanodos});
      # para $nombre, con espacio o no, que puede incluir nodo
      my @pres = grep ($ref->{TIPOTOK}->{$_} eq 'h',sort keys %{$ref->{TIPOTOK}});
      my @nodos = @{$ref->{listanodos}};
      #impr_debug(__LINE__.' Eval t_2_t listanodos',$ref->{listanodos});
      #impr_debug(__LINE__.' Eval t_2_t @pres',\@pres);
      #impr_debug(__LINE__.' Eval t_2_t clasearch',$ref->{clasearch});
      my $cuantos=0; my ($pre,$nodo);
      if ($nombre =~ /^(\w+)\s(\w+)/) {
          $pre = $1; $nodo = $2;
         if (valor($ref,'TIPOTOK',$pre) eq 'h' and 
             valor($ref,'TIPOTOK',$nodo) eq 'm') {
	     $cuantos = 1;
         }; 
      } else {
          foreach my $preo (@pres) {
              foreach my $nodoo (@nodos){
                  if ($nombre eq "$preo$nodoo") {
                      $pre = $preo; $nodo = $nodoo;
                      $cuantos ++;
                  };
              };
          };
      };
      impr_debug(__LINE__.
         " Eval cuantas interpr. hay para tipotok de $nombre:",$cuantos);
      if ($cuantos > 1) { 
          mensajear("qHay varias posibilidades; use parentesis");
	  $coderr = 66;
      } elsif ($cuantos == 1) {  
          #impr_debug(__LINE__.' Eval $pre $nodo',[$pre, $nodo]);
          $ref->{clasearch} eq 'elementos' and $nodo = "NODOELEM$nodo"
	    or $ref->{clasearch} eq 'modelo' and $nodo = "NODOMOD$nodo";
           my $tiparge = "H(m)"; my $refarge = [$pre,$nodo]; 
	  $coderr = 66;
      } else {
          mensajear(
          "No se entiende todavia el token $nombre para referirse a un valor");
          uc($nombre) =~ /^P/ or
          avgrav (
         "No hay chances de que sea definido posteriormente como un parámetro");
          $coderr = 66;
      };  
  };
  not $coderr and $tipotok eq 'w' and not defined $ref->{TIPOTOK}->{$nombre}
  and $ref->{TIPOTOK}->{$nombre} = 'w';
  comfin('finE token_2_tipotok',$coderr,$tipotok,$nombre);
  return $coderr,$tipotok,$nombre;             
} #token_2_tipotok
# ---------------------------------------------------------------------------
sub tratar_tipo_coma{
  comfin('comE tratar_tipo_coma',@_);
#  my ($ref,$que,$cosa,$valor,$tiparg,$refarg) = @_; my $coderr= '';
  my ($ref,$cosa) = @_; my $coderr= ''; 
  impr_dat(__LINE__.' Eval',$cosa,$ref,'ttc');
  my ($tipotok,$valor,$tipo,$tiparg,$refarg,$uni,$ori,$com,$comp,$listacom,$que)
      = tomar_todo_datos($ref,$cosa);
  impr_debug(__LINE__.' Eval', [$tipotok,'||',$valor,'||',$tipo,'||',$tiparg
  ,'||',$refarg,$uni,$ori,$com,$comp,'||',$listacom,'||',$que]);
  impr_debug(__LINE__.' Eval $que',$que);
  if ($tipotok =~ /[ijpt]/) {
      $ref->{TIPOTOK}->{"rerun$cosa"} = $tipotok; 
      cargar_datos($ref,"R$que",'rerun'.$cosa,$valor,',',$tiparg,$refarg);
      impr_dat(__LINE__.' Eval','rerun'.$cosa,$ref,'ttc');
      $ref->{TIPOTOK}->{$cosa} = 'b' unless $tipotok =~ /[t]/;
      my @lista = split ',',$valor;
      # no se esperan parentesis
      $ref->{REFLISTAVALOR}->{$cosa} = \@lista; 
  } elsif (lc($tipotok) eq 'a') {
      error_progr($ref," falta programar formulas para datos; para $cosa");
  } elsif ($que eq 'TIEMPOS') {
  } elsif ($tipotok eq 'd') {
      mensajear("No es aceptable asignar $valor a $cosa");
      $coderr = 1;
  };
  impr_dat(__LINE__.' Eval',$cosa,$ref,'ttc');
  impr_dat(__LINE__.' Eval','rerun'.$cosa,$ref,'ttc');
  comfin('finE tratar_tipo_coma');
  return $coderr;
}#tratar_tipo_coma'
1
