package Simusol::Evaluaciones2;
use Simusol::Ayudas;
use Simusol::Auxiliares;
use Simusol::GlobalesSimusol;
use Simusol::Termicos;
use warnings;
use strict;
use Data::Dumper; 
$Data::Dumper::Sortkeys= 1;
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);

     @ISA=qw(Exporter);
     @EXPORT=qw(
         &crear_par_con_refarg
         &evaluar_g_n   
         &evaluar_numero
         &evaluar_paren_numer
         &evaluar_q_n
         &evaluar_t_n
         &limpiar_lista 
         &partir_refarg
         &pre_limpiar
         &revisar_signos
         &separar_unidad
         &mejorar_tiparg_refarg
         &normalizar_expresion
         &pegar5  
         &simplificar_tiparg
         &tiparg_refarg_2_lisargus
         &vttr
   );
};                
END();
# ---------------------------------------------------------------------------
sub atender_funciones_de_mas{#devuelve $coderr,$tiparg,$refarg 
  comfin('comv atender_funciones_de_mas', @_);
  my ($ref,$reftiparg,$refrefarg,$refsep,$refult) = @_;
  impr_debug(__LINE__.' Eva2 $reftiparg',Dumper $reftiparg);
  impr_debug(__LINE__.' Eva2 $refrefarg',Dumper $refrefarg);
  impr_debug(__LINE__.' Eva2 $refsep',Dumper $refsep);
  impr_debug(__LINE__.' Eva2 $refult',Dumper $refult);
  impr_detallado(__LINE__.' Eva2',$reftiparg,$refrefarg,$refsep,$refult);
  my ($coderr,$tiparg,$refarg) = ('','',[]);
  my $ip = 1;  
  while ($ip < @$reftiparg) {
      my $tipfun = $refult->[$ip-1];my $tipotok = $reftiparg->[$ip]; 
      impr_debug(__LINE__.' Eva2 $tipfun,$tipotok',[$tipfun,$tipotok]); 
      if ($tipfun !~ /[fghkqt]/ or  $refsep->[$ip] ne '(' or 
          length($tipotok) > 1) {
          $ip ++; next;
      };
      my $iq = $ip;
      while ($refsep->[$iq+1] !~ /^\)/) {$iq ++};
      my $fun = $refrefarg->[$ip-1]->[-1];      
      impr_debug(__LINE__.' Eva2 $iq,$fun',[$iq,$fun]);
      if ($ip == $iq) { 
          if ($tipfun =~ /[ft]/) {
              my $absc  = $refrefarg->[$ip]; $fun = $refrefarg->[$ip-1]->[-1];  
              $tipotok eq 'o' and $absc = -$absc;
              ($coderr,my $valor,my $tipo,$tiparg,$refarg)
                = evaluar_funcion($ref,$fun,$tipfun,$absc);
          } elsif ($tipfun eq 'g') { 
              ($tiparg,$refarg) = ($tipotok,[$refrefarg->[$ip]]);
          }  elsif ($tipfun eq 'h') {
              ($coderr,my $valor,$tiparg)
                 = evaluar_funcion_h($ref,$fun,$refrefarg->[$ip]);
              not $coderr and $refarg = [$valor]; 
          } elsif ($tipfun eq 'k') {
              $tiparg = 'k'."[$tipotok]";
              @$refarg = ($fun,$refrefarg->[$ip]);
          };
      } else {
#          if ($tipfun eq 'g'){
#              die "falta programar";
#          } else {
              my $tipargdentro = $reftiparg->[$ip];
              my @refargdentro = @{$refrefarg->[$ip]};
              impr_par(__LINE__.' Eva2',$tipargdentro,\@refargdentro);
              my $ik = $ip +1;
              while ($ik <= $iq) {
                  push @refargdentro,@{$refrefarg->[$ik]};
                  $tipargdentro .= ','.$reftiparg->[$iq];
                  $ik++;
              };
              impr_par(__LINE__.' Eva2',$tipargdentro,\@refargdentro);
              if ($tipfun =~ /[fgkq]/) {
                  $tiparg = $tipfun . "[$tipargdentro]";
                  $refarg = [$fun,@refargdentro];
              };
#	  };
          impr_par(__LINE__.' Eva2',$tiparg,$refarg); 
      };
      if (not $coderr) {
          $reftiparg->[$ip] = $tiparg; @{$refrefarg->[$ip]} = @$refarg;
          my $ik = $ip +1; 
          while ($ik <= $iq) {
 #             delete $reftiparg->[$ik]; delete $refrefarg->[$ik];
 #             delete $refsep->[$ip];delete $refult->[$ip-1];
              $ik++;
          };
          impr_debug(__LINE__.' Eva2 $reftiparg',Dumper $reftiparg);
          impr_debug(__LINE__.' Eva2 $refrefarg',Dumper $refrefarg);
  impr_debug(__LINE__.' Eva2 $refsep',Dumper $refsep);
  impr_debug(__LINE__.' Eva2 $refult',Dumper $refult);
          ($refult->[$ip] = $reftiparg->[$ip]) =~ s/^.*(.)$/$1/; 
#           pop $refrefarg->[$ip-1];
            my @listaref = @{$refrefarg->[$ip-1]}; pop @listaref;
	    $refrefarg->[$ip-1] = \@listaref;
            $reftiparg->[$ip-1] =~ s/.$//; 
          impr_detallado(__LINE__.' Eva2', $reftiparg,$refrefarg,$refsep,$refult);
          mover_izq($reftiparg,$refrefarg,$refsep,$refult,$ip);
          impr_detallado(__LINE__.' Eva2',$reftiparg,$refrefarg,$refsep,$refult);
#          if (not $reftiparg->[$ip-1]) {
#	      delete $reftiparg->[$ip-1];delete $refrefarg->[$ip-1];
#              $ip --;
#          };
          impr_debug(__LINE__.' Eva2 $reftiparg',Dumper $reftiparg);
          impr_debug(__LINE__.' Eva2 $refrefarg',Dumper $refrefarg);
      };
      impr_detallado(__LINE__.' Eva2'.$reftiparg,$refrefarg,$refsep,$refult);
      $ip ++; 
  };#$ip    
  comfin('finv atender_funciones_de_mas', $coderr);
  return $coderr;
}#atender_funciones_de_mas';
# ---------------------------------------------------------------------------
sub atender_funcion_de_un{#devuelve $coderr,$tiparg,$refarg 
  comfin('comv atender_funcion_de_un', @_);
  my ($ref,$fun,$tipfun,$token,$tiptoken) = @_;
  my ($coderr,$tiparg,$refarg) = ('','',[]);
  if ($tipfun eq 'g') {
     ($tiparg,$refarg) = ($tiptoken,[$token]);
  } else {
      if ($tiptoken =~ /[no]/) {
          if ($tipfun =~ /[ft]/) {
              my $absc  = $token;
              $tiptoken eq 'o' and $absc = -$absc;
              ($coderr,my $valor,my $tipo,$tiparg,$refarg)
                 = evaluar_funcion($ref,$fun,$tipfun,$absc);
          } elsif ($tipfun eq 'h') {
              ($coderr,my $valor,$tiparg)
                 = evaluar_funcion_h($ref,$fun,$token);
              not $coderr and $refarg = [$valor]; 
          } elsif ($tipfun eq 'k') {
              $tiparg = 'k'."[$tiptoken]";
              @$refarg = ($fun,$token);
          } elsif ($tipfun eq 'q') {
              ($coderr,$tiparg,$refarg)
                 = evaluar_q_n($ref,$fun,$tiptoken,[$token]);
          };
      } else {
          $tiparg = $tipfun."[$tiptoken]";
          $refarg = [$fun,$token];
      };
  };    
  comfin('finvv atender_funcion_de_un',$coderr,$tiparg,$refarg);
  return $coderr,$tiparg,$refarg
}#atender_funcion;
# ---------------------------------------------------------------------------
sub aumentar_creados{#devueve $coderr y lo creado o ...
  comfin('com aumentar_creados',@_);
  my ($ref,$valor) = @_;my ($coderr,$cual) = ('','');
  $valor =~ /(\w+)\[(.*)\]/; my $dentro = $2;
  
  comfin('com aumentar_creados',@_);
  return $coderr,$cual;
}#aumentar_creados
# ---------------------------------------------------------------------------
sub crear_par_con_refarg{#devueve $coderr,$newpar,......$tiposust,$refargsust
  comfin('comv crear_par_con_refarg', @_);
  my ($ref,$iden,$valor,$tipovalor, $tiparg,$refarg) = @_;
  my ($coderr,$newpar,$tipo,$tiposust) = ('','','','');
#  impr_debug(__LINE__.' Eva2 valor2cual',Dumper $ref->{valor2cual});
  if ($valor eq '' or $tipovalor eq '' ) {
      ($coderr,$valor,$tipo,$tiparg,$refarg)
        = tiparg_refarg_2_vttr_talcual($tiparg,$refarg,__LINE__.' Eva2'); 
     if ($coderr) {
         comfin('finv crear_par_con_refarg linea,$coderr',__LINE__,$coderr);
         return $coderr;
      };  
  };
  not $tipo and $tipovalor and $tipo = $tipovalor;
#  impr_debug(__LINE__.' Eva2 $valor,$tipo,$tiparg,$refarg'
#    ,[$valor,$tipo,$tiparg,'||',@$refarg]);
  my $refargsust = [];
  impr_par(__LINE__.' Eva2 com crear_par_c_r',$tiparg,$refarg);
  if (scalar keys %$ref == 0) {
      error_progr($ref,__LINE__." Eva2 \$ref vacio");
  };
  if ($tiparg =~ /^[fon\W]+$/) {
     ($coderr,$tiparg,$refarg) = evaluar_tiparg_refarg_numerico(
       $tiparg,$refarg);
     if ($coderr) {
         comfin('finv crear_par_con_refarg linea,$coderr',__LINE__,$coderr);
         return $coderr;
     };
     if ($iden ne 'O') {# algo no pedido como resultado
         $coderr = '1';# no se crea el par al ser numero
         $valor = $refarg->[0]; $tiparg eq 'o' and $valor = -$valor;
         $tipo = $tiposust = $tiparg; $refargsust = $refarg;
         $newpar = $valor;
         comfin(
          'finv crear_par_con_refarg linea,$coderr'
           .',$newpar,$valor,$tipo,$tiparg,$refargsust'
           ,__LINE__,$coderr
           ,$newpar,$valor,$tipo,$tiparg,$tiposust,'||',@$refargsust);
         return $coderr,$newpar
           ,$valor,$tipo,$tiparg,$refarg,$tiposust,$refargsust;
     }; 
  };
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  if (defined $ref->{valor2cual}->{$valor}) {
      $newpar = $ref->{valor2cual}->{$valor}->[0];
      #aqui solo hay valores de parámetros $tipotok = 'p';
      #  o de elementos de valor numerico 
      #ya hay otro parametro valido con igual valor
      ($valor,$tipo,$tiparg,$refarg) = tomar_cua_datos($ref,$newpar);
      impr_debug(__LINE__.' Eva2 $valor $tipo',[$valor,$tipo]);
  };
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  impr_debug(__LINE__.' Eva2 $newpar',$newpar);
  if (not $newpar) {
     my $numpar = 1;
     #en $ref->{parscreados} se mantienen  parametros creados vigentes; 
     #si se borra un parámetro creado anteriormente se borra de ahi
     while (defined $ref->{TIPOTOK}->{"P$iden$numpar"}) {
        $numpar++;
     };#while
     $newpar = "P$iden$numpar";
     impr_debug(__LINE__.' Eva2 $newpar',[$newpar,$valor,$tipo,$tiparg]);
     $ref->{parscreados}->{$newpar} = 1;
     my $pars = 'PARAMETROS'; my $uni = '';
     if (@$refarg == 1 and $tiparg !~ /[no]/) {
	 $uni = Simusol::Resultados::compear_sceptre($ref,$refarg->[0]);
     };
     cargar_datos_tipotok($ref, "P$pars",$newpar, 'p',$valor,$tipo,$tiparg
  	   ,$refarg,'',$uni,$valor,'');
     if ($iden eq 'Z') {push @{$ref->{listaZPARAMETROS}},$newpar;
     } elsif ($iden eq 'Y') {push @{$ref->{listaYPARAMETROS}},$newpar;
     };
     defined $ref->{listaUSO_DEF} and $iden = 'USO_DEF';
#     push @{$ref->{valor2cual}->{$valor}},$newpar;
  };
  $tiposust = 'p';
  $tipo eq 'P' and $tiposust = 'P';
  impr_dat(__LINE__.' Eva2',$newpar,$ref,'cre');
  comfin('finv crear_par_con_refarg linea'
    .'__LINE__,$coderr,$newpar,$valor,$tipo,$tiparg,$refarg,$tiposust'
    ,__LINE__,$coderr,$newpar,$valor,$tipo,$tiparg,$refarg,$tiposust);
  return $coderr,$newpar,$valor,$tipo,$tiparg,$refarg,$tiposust;
}#crear_par_con_refarg
# ---------------------------------------------------------------------------
sub desmembrar_expresion{#calcula listas @listramo y @lissetr
  comfin('comv desmembrar_expresion',@_);
  my($ref,$que,$expresionori,$mens_desm) = @_;
  my ($coderr,$newexpr) = ('',$expresionori);
#  my($coderr,$newexpr,$pendiente) = parentesis_bien_marcar($expresionori);
#  if ($coderr) {
#      push @MENSAJES, $coderr; 
#      comfin('finv desmembrar_expresion linea,$coderr,$mens_desm'
#             ,__LINE__,$coderr,$mens_desm);
#      $coderr = 30;
#      return $coderr;
#  };
  $newexpr = " $newexpr";
  impr_debug(__LINE__.' Eva2 $newexpr',$newexpr);
  $newexpr =~ s/^.//;
  impr_debug(__LINE__.' Eva2 $newexpr',$newexpr);
  #no habra mas de un []
  my $expresion = "[$newexpr]";
  my @lissetr = split /[\-+*\/\(\)\.\^\w]+/,$expresion;
  # enseguida se retiran de @lissepa los parentesis agregados
  # y se retira de @listramo el tramo nulo inicial
  $lissetr[0] =~ s/^\[//; $lissetr[-1] =~ s/\]$//;
  impr_debug(__LINE__.' Eva2',Dumper \@lissetr); 
  my @listramo = split /[,\[\]]+/,$expresion; shift @listramo; 
  impr_debug(__LINE__.' Eva2 tramos',Dumper \@listramo); 
#  my $reftipargt = ['']; my $refrefargt = [[]];
  my $tipargtodo = $lissetr[0]; my $refargtodo = []; my $tipo= '';
  for (my $it = 0; $it < @listramo; $it ++) {
      my $tramo = $listramo[$it];
      my $itant = $lissetr[$it];my $itpost = $lissetr[$it+1];
      impr_par(__LINE__.' Eva2 todo',$tipargtodo,$refargtodo);
      impr_debug(__LINE__.' Eva2 $it,$tramo',['..............',$it,$tramo]);
      ($coderr,my ($tipargt,$refargt))
        = detallar_tramo($ref,$itant,$tramo,$itpost);
      if (not $coderr) {
          $tipargtodo .= $tipargt; push @$refargtodo,@$refargt; 
          impr_par(__LINE__.' Eva2 todo',$tipargtodo,$refargtodo);
          while ($itpost =~ s/^\]//) {
              ($coderr,$tipargtodo,$refargtodo) = revisar_funcion(
                $ref,$tipargtodo,$refargtodo,$itpost);
              impr_par(__LINE__.' Eva2 todo',$tipargtodo,$refargtodo);
              impr_debug(__LINE__.' Eva2 $itpost',$itpost);
              impr_par(__LINE__.' Eva2 todo despues',$tipargtodo,$refargtodo);
              if ($itpost and $itpost !~ /^\]/) {
                  ($coderr,$tipargtodo,$refargtodo)
	          = detallar_extension_tramo(
                    $ref,$tipargtodo,$refargtodo);
	      };
           };
#           if ($itpost =~ /^,/) {
#               if (length($tipargtodo 
           impr_par(__LINE__.' Eva2 todo',$tipargtodo,$refargtodo);
           if (not $coderr) {
              impr_debug(__LINE__.' Eva2 @lissetr',\@lissetr);  
              impr_debug(__LINE__.' Eva2 tramo ',$it);
          };
          impr_debug(__LINE__.' Eva2 fin tramo ',$it);
      };
  };
  if (not $coderr) {
      impr_par(__LINE__.' Eva2 ultimo',$tipargtodo,$refargtodo);
      my $cuantos = $tipargtodo =~ tr/[no]//; 
      ($coderr,$tipargtodo,$refargtodo)
        = evaluar_terms_nuevo($tipargtodo,$refargtodo) if $cuantos >1; 
      impr_par(__LINE__.' Eva2 todo',$tipargtodo,$refargtodo) if not $coderr;
  } else {
      push @MENSAJES," Errores en $expresionori";
          comfin('finv desmembrar_expresion linea $coderr'
	    ,__LINE__.' Eva2',$coderr); return $coderr;
  };
  comfin('finv desmembrar_expresion',$coderr,$tipargtodo,'||',@$refargtodo);
  return $coderr,$tipargtodo,$refargtodo;
}#desmembrar_expresion
# ---------------------------------------------------------------------------
sub detallar_extension_tramo{# $coderr,$tiparg,$refarg
  comfin('comv detallar_extension_tramo',@_);
  my ($ref,$tipargtodo,$refargtodo,$mens_det) = @_;my $coderr = '';
  if ($tipargtodo =~ /^(.*)([\[,])([^\[,]*)$/) {
      impr_debug(__LINE__.' Eva2 $1,$2,$3',[$1,$2,$3]);
      my ($comi,$itint,$tramotiparg) = ($1,$2,$3);
      if ($itint) { 
          my ($comirefarg,$tramorefarg) 
            = separar_refarg($tipargtodo,$refargtodo,$tramotiparg);
          my $cuantosn = ($tramotiparg =~ tr/no//);
          if ($cuantosn>1) {
              ($coderr,$tramotiparg,$tramorefarg) 
                = evaluar_terms_nuevo($tramotiparg,$tramorefarg);
              if (not $coderr and length($tramotiparg) > 1) {  
                 my($coderr,$newpar,$valor,$tipo,$tramotiparg,$tramorefarg
                   ,$tiposust) = crear_par_con_refarg(
                    $ref,'A','','',$tramotiparg,$tramorefarg);
              };
              if (not $coderr) {
                  $tipargtodo = "$comi$itint$tramotiparg";
                  push @$comirefarg,@$tramorefarg;
                  @$refargtodo = @$comirefarg;
              };
          };
      };
  };
  comfin('finv detallar_extension_tramo',$coderr,$tipargtodo,'||',@$refargtodo);
return $coderr,$tipargtodo,$refargtodo;
}#detallar_extension_tramo
# ---------------------------------------------------------------------------
sub detallar_tramo{#devuelve $coderr,$tiparg,$refarg
  comfin('comv detallar_tramo', @_); 
  my ($ref,$itant,$tramo,$itpost,$mens_det) = @_;my $coderr = '';
  my $ittramoit = ";$tramo;";
  my @lispal = split /[-+*\/\(\)\[\];\^]+/,$ittramoit;
  shift @lispal;
  my @lissepa = split /[\w\.]+/,$ittramoit;
  $lissepa[-1] =~ s/;$//; $lissepa[0] =~ s/^;//;
  impr_debug(__LINE__.' Eva2 ',Dumper \@lissepa);
  impr_debug(__LINE__.' Eva2 ',Dumper \@lispal);
  my $cuantos = @lispal;
  my ($tiparg,$refarg) = ($lissepa[0],[]);
  my $ip = 0;
  while ($ip < @lispal) {
      my ($valor,$nombres,$tipo);
      $valor = $lispal[$ip]; $nombres = '';
      if ($valor =~ s/^\s*([\.\d])/$1/) {
          ($coderr,my $deltaip,$nombres,my $nvalor)
             = intentar_numero(\@lispal,\@lissepa,$ip);
          if (not $coderr) {
              $ip = $ip + $deltaip; $tipo = 'n'; $valor = $nvalor;
              
          } elsif ($coderr and $valor =~ /^\d/) {
              my $tipotok = valor($ref,'TIPOTOK',$valor);
              if ($tipotok eq 'm') {
                  $coderr = ''; $tipo = 'm';
              };
          };
          if ($coderr) {
              push @MENSAJES," $nombres no es numero ni nombre de nodo";
              $coderr = 31;
              comfin('finv detallar_tramo_expresion linea,$coderr,$mens_desm'
                ,__LINE__,$coderr,$mens_det);
              return $coderr;
          };
      } else {
          $valor =~ s/\s$//;
          my $tipotok = valor($ref,'TIPOTOK',$valor);
          impr_debug(__LINE__.' Eva2 $tipotok',$tipotok);
          if ($tipotok) {
              if ($tipotok =~ /^[SW]/) {$tipo = $tipotok;
              } else {$tipo = lc($tipotok)};
          } else {
             if ($ip == $cuantos - 1 and $lissepa[$ip+1] eq ''
                and $itpost eq '[') {
                 $tipo = 'k';
             } else {
                 $tipo = 'w';
             };
             $ref->{TIPOTOK}->{$valor} = $tipo;
          };
          $nombres = $valor;   
      };
      $tiparg .= $tipo;
      $tiparg .= $lissepa[$ip+1] if $lissepa[$ip+1] ne ' ';
      push @$refarg,$valor;
      $ip++;
  };#while $ip
  $tiparg =~ s/\s//g;
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  my($tipoultimo,$ultimo);
  $tiparg =~ /(.)$/ and $tipoultimo = $1;
  $ultimo = $refarg->[-1];

  if ($itpost =~ /^\[/) {
      if ($tipoultimo =~ /[fghkqt]/) {
      } else { 
        push @MENSAJES, " No se entiende $ultimo no seguido de (";$coderr = 9;
      };
  } else {#solo puede ser , o ''
      if ($tipoultimo !~ /[fghkqt]/) {
      } else {
        push @MENSAJES, " No se entiende $ultimo seguido de (";$coderr = 10;
      };
  };
  if ($coderr) {
      comfin('finv detallar_tramo_expresion linea,$coderr,$mens_desm'
        ,__LINE__,$coderr,$mens_det);
      return $coderr;
  };
  if (length $tiparg >1) {
      $tiparg = simplificar_tiparg($tiparg);
      impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  };
  if ($itant =~ /[\[,]$/ and $itpost =~ /^[,\]]/ and length($tiparg) >1) {
      my ($coderr,$newpar,$valor,$tipo,$tipargp,$refargp,$tiposust)
        = crear_par_con_refarg($ref,'A','','',$tiparg,$refarg);
      $tiparg = $tiposust; @$refarg = [$newpar];
  }
  if (not $coderr and $itpost =~ /[\[,]/) {
      $tiparg .= $itpost;
  };

  comfin('finv detallar_tramo',$coderr,$tiparg,'||',@$refarg);
  return $coderr,$tiparg,$refarg
}#detallar_tramo
# ---------------------------------------------------------------------------
sub evaluar_funcion{#devuelve $coderr,$valor,$tipo,$tiparg,$refarg para f o t 
  comfin('comv evaluar_funcion', @_);
  my($ref,$func,$tipofunc,$absc) = @_;
  my($coderr,$valor,$tipo,$tiparg,$refarg) = ('','','','',[]);
  if ($tipofunc eq 'f') {
      ($coderr,$valor,$tipo,$tiparg,$refarg) = evaluar_numero("$func($absc)");
  } elsif ($tipofunc eq 't') {
      ($coderr,$valor,$tipo,$tiparg,$refarg) = evaluar_t_n($ref,$func,$absc);
  } else {
    error_progr(35,__LINE__.' Eva2');
  };
  comfin('finv evaluar_funcion linea,$coderr,$valor,$tipo,$tiparg,$refarg'
     ,__LINE__,$coderr,$valor,$tipo,$tiparg,$refarg);
  return $coderr,$valor,$tipo,$tiparg,$refarg;
}#evaluar_funcion');
# ---------------------------------------------------------------------------
sub evaluar_g_n{#devuelve $coderr,$valor,$tipo,$tiparg,$refarg 
  # se llega aqui con valores que son funciones QPRODUCTO o QSUMA 
  # evaluadas en $dentro que es lista de numeros con posibles signos
  # retorna codigo de error ''  valor, tipo, tiparg y refarg
  comfin('comv evaluar_g_n', @_);
  my ($func,$tiparg,$refarg) = @_;
  my ($oper,$valor) = ('*',1);
  my @listiparg = split (',',$tiparg); 
  $func eq 'QSUMA' and ($oper,$valor) = ('+',0);
  foreach my $cosa (@$refarg) {
      my $valorcito = $cosa; my $tipito = shift @listiparg;
      $tipito eq 'o' and $valorcito = -$valorcito;
      $valor = eval("$valor $oper $valorcito");
  };
  my $tipo = 'n'; $valor < 0 and $tipo = 'o';
  my $newtiparg = $tipo; my $newrefarg = [abs($valor)];  
#  my ($coderr,$newtiparg,$newrefarg)
#    = tiparg_refarg_2_lisargus($func,$tiparg,$refarg);
#  my $valor = tiparg_refarg_2_valor_talcual($newtiparg,$newrefarg);
#  my $tipo = substr($newtiparg,0,1);
  comfin('finv evaluar_g_n', '',$valor,$tipo,$newtiparg,'||',@$newrefarg);  
  return '',$valor,$tipo,$newtiparg,$newrefarg;
} #evaluar_g_n
# ---------------------------------------------------------------------------
sub evaluar_numero{#devuelve $coderr,$valor,$tipo,$tiparg,$refarg
#  comfin('comv evaluar_numero',@_);
  my $valor = $_[0]; my $coderr = '';
  use warnings  FATAL => qw(syntax void);
  my $valorc = eval lc($valor);
   ($@ or not defined $valorc) and do {
      push @MENSAJES, " No se puede calcular $valor; no es un número";
      $coderr = 66;
      comfin('finv evaluar_numero',$coderr,$valor);
      return $coderr;
  };
  $valor = $valorc; my $tipo = 'n'; my $tiparg = 'n'; my $refarg = [$valor];
  $valor < 0 and do {$tipo = $tiparg = 'o';$refarg = [-$valor]};
#  comfin('finv evaluar_numero',$coderr,$valor,$tipo
#     ,$tiparg,'||',@$refarg);
  return $coderr,$valor,$tipo,$tiparg,$refarg;  
} #evaluar_numero
# ---------------------------------------------------------------------------
sub evaluar_paren_numer{#no hay parentesis curvos funcionales
  comfin('comv evaluar_paren_numer',@_);
  my($tiparg0,$refarg0) = @_; my $coderr = '';
  #le he sacado el $ref  
  impr_par(__LINE__.' Eva2 0 s_p_n',$tiparg0,$refarg0);
  my $tiparg = $tiparg0; my $refarg = []; @$refarg = @$refarg0;
#  $tiparg=~ s/\(-n\)/o/g;
  while ($tiparg =~ /^(.*)([\(,])([no][\+\-\*\/no]+)([\),])(.*)$/) {
      my ($tiparg0,$simb1,$tiparg1,$simb2,$tiparg2) = ($1,$2,$3,$4,$5);
      impr_debug(__LINE__.' Eva2 $3',$3);
      if (length($3) < 3) {
          my $parte = $3; 
          impr_debug(__LINE__.' Eva2',$parte);  
          $parte =~ tr/no/JK/;
          impr_debug(__LINE__.' Eva2',$parte);  
	  $tiparg = $tiparg0.$simb1.$parte.$simb2.$tiparg2;
          impr_par(__LINE__.' Eva2 inter',$tiparg,$refarg);
	  next;
      }; 
      impr_debug(__LINE__.' Eva2 $simb1 $tiparg1 $simb2'
        ,"$simb1 $tiparg1 $simb2"); 
      my ($refarg0,$refarg1,$refarg2)
        = partir_refarg($refarg,"$tiparg0$simb1",$tiparg1,"$simb2$tiparg2");
      impr_debug(__LINE__.' Eva2 $refarg0,$refarg1',[@$refarg0,'||',@$refarg2]);
      impr_par(__LINE__.' Eva2',$tiparg1,$refarg1); 
       ($coderr,my ($tiparg11,$refarg11))
	   = evaluar_tiparg_refarg_numerico($tiparg1,$refarg1);
       if ($coderr) {
          comfin('finv evaluar_paren_numer linea $coderr',__LINE__,$coderr);
          return $coderr;
      } else {
           @$refarg =(@$refarg0,@$refarg11,@$refarg2);
           ($tiparg,$refarg) = 
              pegar5($tiparg0,$simb1,$tiparg11,$simb2,$tiparg2
	  ,$refarg0,$refarg11,$refarg2,'(',')');
       impr_par(__LINE__." Eva2 ciclo s_p_n\n",$tiparg,$refarg);
      };
  };#while
  impr_par(__LINE__.' Eva2 s_p_n',$tiparg,$refarg);
  $tiparg =~ tr/JK/no/;
  impr_par(__LINE__.' Eva2 s_p_n',$tiparg,$refarg);
#  $tiparg = simpl_paren_o($tiparg);
  impr_par(__LINE__.' Eva2 s_p_n',$tiparg,$refarg);
  comfin('finv evaluar_paren_numer',$coderr,$tiparg,@$refarg);
  return $coderr,$tiparg,$refarg;
}#evaluar_paren_numer
# ---------------------------------------------------------------------------
sub evaluar_q_n{#devuelve $coderr,$valor,$tipo,$tiparg,$refarg
  comfin('comv evaluar_q_n',@_);
  # se llega aqui con valores que son funciones-Q evaluadas en una lista
  #1 o mas  numeros 
  # retorna codigo de error y mensaje, y si es posible, tiparg refarg
  my ($ref,$func,$tiparg,$refarg) = @_;my ($coderr,$mensaje) = ('','');
  my ($tipotok,$valor,$tipo,$tipargfunc,$refargfunc) = tomar_todo_datos(
    $ref,$func);
  impr_par(__LINE__.' Eva2 para funcion',$tipargfunc,$refargfunc);
  my @rfuncion = @$refargfunc;
  impr_par(__LINE__.' Eva2',$tipargfunc,$refargfunc);
  if ($tipotok ne 'Q') {
      $mensaje = " No es posible calcular $func($valor)";$coderr = -1;
      comfin('finv evaluar_q_n',-1,$mensaje); 
      return $coderr,$mensaje;
  };
  my $lisformales = $ref->{listaargFUNCION}->{$func}; 
  my @lisactuales = @$refarg;
  if (@$lisformales != @lisactuales) { 
      push @MENSAJES, " $func definida con ". scalar @$lisformales. " argumentos
             y usada con ".  scalar @lisactuales;
      $coderr = 33;
      comfin('finv evaluar_q_n',$coderr); 
      return $coderr;
  }; 
  # en @rfuncion hay que cambiar los arg.formales por los actuales
  #como los actuales son numeros y los formales no lo son,
  #no hay peligro de doble sustitucion 
  impr_debug(__LINE__.' Eva2 @rfuncion',\@rfuncion);
   my @listipactuales = split ',',$tiparg;  
  for (my $i = 0; $i < @lisactuales; $i++) { 
      $listipactuales[$i] eq 'o' and $lisactuales[$i] = "-$lisactuales[$i]";
      map(do{$_ eq $lisformales->[$i] and $_ = $lisactuales[$i]},@rfuncion);
  };
  impr_debug(__LINE__.' Eva2 formales actuales'
    ,[@$lisformales,'||',@lisactuales]);
  impr_debug(__LINE__.' Eva2 @rfuncion',\@rfuncion);
  my $valortalcual = tiparg_refarg_2_valor_talcual(
    $tipargfunc,\@rfuncion,'Eva2 '.__LINE__);
  ($coderr,$valor,$tipo,$tipo,$refarg)
      = vttr($valortalcual);
# recordar cargar $ref->{FUNCIONESsustituidas}
  comfin(
   'finv evaluar_q_n', $coderr,$valor,$tipo,$tipo,'||',@$refarg);
  return $coderr,$valor,$tipo,$tipo,$refarg;
}#evaluar_q_n
    
# ---------------------------------------------------------------------------
sub evaluar_t_n{#devuelve $coderr,$valor,$tipo,$tiparg,$refarg
  #guarda los valores o para con mensaje de error
  comfin('comv evaluar_t_n', @_);  
  my ($ref,$Tidtabla,$absc) = @_; my ($coderr,$mensaje)= ('','');
  impr_debug(__LINE__.' Eva2 $ref->{sobreTABLAS}',Dumper $ref->{sobreTABLAS});
  impr_debug(__LINE__.' Eva2 $Tidtabla,$absc',[$Tidtabla,$absc]);
  impr_datos(__LINE__.' Eva2 ref',['TABLAS'],$ref);
  my @abscisas = @{$ref->{sobreTABLAS}->{$Tidtabla}->{absTABLAS}};
  if ($absc < $abscisas[0] or $absc > $abscisas[-1]) {
       push @MENSAJES, " Abscisa $absc para $Tidtabla fuera de rango
                   $abscisas[0]  :  $abscisas[-1]";
       comfin('finv evaluar_t_n $coderr',-1); 
       return -1;
  };
  my @ordenadas = @{$ref->{sobreTABLAS}->{$Tidtabla}->{ordTABLAS}};
  impr_debug(__LINE__.' Eva2 @abscisas,@ordenadas',[@abscisas,'||',@ordenadas]);
  my ($valor,$tipo,$tiparg,$refarg);
  my ($iantes,$idespues,$abantes,$abdespues,$valorantes,$valordespues);
  for (my $i= 0; $i < @abscisas; $i ++) {
      next if $absc < $abscisas[$i];
      $iantes = $i;last;
  };
  for (my $i= @abscisas-1; $i >= 0; $i --) {
      next if $absc > $abscisas[$i];
      $idespues = $i;last;
  };
  $abantes = $abscisas[$iantes]; $abdespues = $abscisas[$idespues];
  $valorantes = $ordenadas[$iantes];
  $valordespues = $ordenadas[$idespues];
  if ($iantes == $idespues) {
      $valor = $ordenadas[$iantes];
  } elsif ($valorantes == $valordespues) {
      $valor = $valorantes;
  } else {
      $valor = $valorantes
        + ($absc-$abantes)*($valordespues-$valorantes)/($abdespues-$abantes);
      $valor = sprintf("%6G",$valor);
  };
  ($coderr,my($nvalor,$tipito,$tipargcito,$refargcito))
     = evaluar_numero($valor); 
  $ref->{TABLASsustituidas}->{$Tidtabla} = 1;
  comfin('finv evaluar_t_n'
    ,$coderr,$valor,$tipito,$tipargcito,'||',@$refargcito);
  return $coderr,$valor,$tipito,$tipargcito,$refargcito;
}#evaluar_t_n 
# ---------------------------------------------------------------------------
sub evaluar_factors{#devuelve $coderr,#$tiparg,$refarg
  #detecta factor numerico
  # dentro o fuera de parentesis curvo; sin mezclar
  comfin('comv evaluar_factors',@_);
  my ($tipargori,$refargori) = @_; my $coderr = '';
  my $tiparg ="+$tipargori";# y uso ; para impedir avance
  impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  my ($refarg,$newrefarg) = ([],[]);
  @$refarg = @$refargori;
  impr_par(__LINE__.' Eva2 0',$tiparg,$refarg);
  comfin('finvv evaluar_factors',$coderr,$tiparg,$refarg);
}# evaluar_factors
# ---------------------------------------------------------------------------
sub evaluar_terms_nuevo{#devuelve $coderr,#$tiparg,$refarg
  #detecta termino numerico y lo junta con el siguiente si tambien lo es
  # dentro o fuera de parentesis curvo; sin mezclar
  comfin('comv evaluar_terms',@_);
  my ($tipargori,$refargori) = @_; my $coderr = '';
  (my $tiparg = "$tipargori+") =~ s/^([no])/+$1/;
  # y uso ; para indicar no posible
  impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  my ($refarg,$newrefarg) = ([],[]);
  @$refarg = @$refargori;
  impr_par(__LINE__.' Eva2 0',$tiparg,$refarg);

  my $comi ='[-+(,]'; my $final = '[-+),]';my $corazon = '[no\*\/]+[-+]';
  my $otro = '[no\*\/]+';my $buscar = $corazon . $otro; my $largo = 2; 
  ($coderr,$tiparg,$refarg)
      = procesar_largo($tiparg,$refarg,$comi,$buscar,$final,$largo);
  impr_par(__LINE__.' Eva2 ',$tiparg,$refarg);
  $tiparg =~ s/^([no])/+$1/; 

  if (not $coderr) {
      $buscar = $otro; $largo = 2; 
      ($coderr,$tiparg,$refarg)
        = procesar_largo($tiparg,$refarg,$comi,$buscar,$final,$largo);
      impr_par(__LINE__.' Eva2 ',$tiparg,$refarg);
      $tiparg =~ s/^([no])/+$1/;
  };
  if (not $coderr) {
      impr_par(__LINE__.' Eva2 ',$tiparg,$refarg);
      $buscar = 'n\^n';$comi = $final = ''; $largo = 0;
      ($coderr,$tiparg,$refarg)
        = procesar_largo($tiparg,$refarg,$comi,$buscar,$final,$largo);
      impr_par(__LINE__.' Eva2 ',$tiparg,$refarg);
      $tiparg =~ s/^\+//;$tiparg =~ s/\+$//;
  };

  if (not $coderr) {
      impr_par(__LINE__.' Eva2 ',$tiparg,$refarg);
      if ($tiparg =~ /\(o\)\^/ or $tiparg =~ /o\^/) {
          push @MENSAJES," por favor, no use base negativa en una potencia;
          si puede, use producto";
          $coderr = 32;
      };
  };
  comfin('finv evaluar_terms',$coderr,$tiparg,$refarg);
  return $coderr,$tiparg,$refarg;
}#evaluar_terms_
# ---------------------------------------------------------------------------
sub intentar_numero{ # aqui numero no es negativo
#  comfin('comv intentar_numero',@_);
  my ($reflispal,$reflissepa,$ipori) = @_; my $ip = $ipori;
  my $coderr = '';
  my ($cod,$nombres,$valor,$tipo,$tiparg,$refarg)
    = ('',$reflispal->[$ip],'','','',[]);
#  impr_debug(__LINE__.' Eva2 $coderr, $nombres',[$coderr,$nombres]);
  if ($nombres =~ /[DE]$/) {
      if (@$reflispal > $ip+1
        and $reflissepa->[$ip+1] =~ /^[+-]$/
        and $reflispal->[$ip+1] =~ /^\d+$/ ) {
          $nombres .= "$reflissepa->[$ip+1]$reflispal->[$ip+1]";
          $ip ++;
      } else {
          push @MENSAJES, " $nombres no es un número"; 
          $coderr = 33;
      };
  } elsif ($nombres =~ /[DE]\s+$/) {
      push @MENSAJES, " falta exponente en $nombres";
      $coderr = 33;
  };
#  impr_debug(__LINE__.' Eva2 $coderr,$nombres',[$coderr,$nombres]); 
  my $cuantosp = ($nombres =~ tr///); 
  if ($cuantosp > 1) {
      push @MENSAJES, " $nombres tiene más de un punto decimal"; 
      $coderr = 33;
  }; 
#  impr_debug(__LINE__.' Eva2 $coderr',$coderr);
  if ($coderr) {
      push @MENSAJES," Empieza como número pero no lo es: $nombres"; 
  } else {
      ($coderr,$valor) = evaluar_numero($nombres);
  };
  if (not $coderr) {  
#      impr_debug(__LINE__.' Eva2 $valor',['||',$valor,'||']);
      if($valor) {
          $valor = para_sceptre_num($valor);
      };
  };
  my $deltaip = $ip - $ipori;
#  comfin('finv intentar_numero',$coderr,$deltaip,$nombres,$valor);
  return $coderr,$deltaip,$nombres,$valor;
}#intentar_numero
# ---------------------------------------------------------------------------
sub explotar_mas{#devuelve $coderr,$tiparg,$refarg
  comfin('comv explotar_mas',@_);
  my($ref,$func,$tipofunc,$tipargd,$refargd) = @_;
  my ($coderr,$mensaje) = ('','');
  my $refarg = [];my $tiparg = ''; my $tipo = $tipofunc;
  @$refarg = ($func,@$refargd); $tiparg = "$tipofunc($tipargd)";
  my $valor = tiparg_refarg_2_valor_talcual($tiparg,$refarg,'Eva2 '.__LINE__);
  my $valord = tiparg_refarg_2_valor_talcual($tipargd,$refargd
    ,'Eva2 '.__LINE__);
  if ($tipofunc eq 'g') {
      if (@$refargd == 1) {
          @$refarg = @$refargd; $tiparg = $tipargd;
      } elsif ($tipargd =~ /^[no,]+$/) {
            ($coderr,$mensaje,$valor,$tipo,$tiparg,$refarg)
             = evaluar_g_n($func,$tipargd,$refargd);
      } else {
          ($coderr,my($newpar,$valor,$tipop,$tipargp,$refargp,$tiposust))
	      = crear_par_con_refarg($ref,'G',$valor,'g',$tiparg,$refarg);
          $refarg = [$newpar];$tipo = $tiparg = $tiposust;
          $valor = $newpar;
      };
  } elsif (valor($ref,'TIPOTOK',$func) eq uc($tipofunc)
           and  $tipargd =~ /^[no,]+$/) {
      if ($tipofunc eq 'q') {
          ($coderr,$mensaje,$valor,$tipo,$tiparg,$refarg)
	      = evaluar_q_n($ref,$func,$tipargd,$refargd);
      } elsif ($tipofunc eq 't') {
          ($coderr,$mensaje,$valor,$tipo,$tiparg,$refarg)
	      = evaluar_t_n($ref,$func,$valord);
      };
  } elsif ($tipofunc eq 'f' and $tipargd =~ /^[no,]+$/) {
      ($coderr,$tiparg,$refarg)
     = evaluar_tiparg_refarg_numerico("$tipofunc($tipargd)",[$func,@$refargd]);
      $mensaje and mensajear($mensaje);   
  };
  comfin('finv explotar_mas $coderr,$tiparg,$refarg',$coderr,$tiparg,$refarg);
  return $coderr,$tiparg,$refarg;
}#explotar_mas
# ---------------------------------------------------------------------------
sub intentar_func_sin_blancos{
  comfin('comv intentar_func_sin_blancos',@_);
  my ($ref,$func) = @_;
  my $tipotok = valor($ref,'TIPOTOK',$func); my $tipo;
  if (not $tipotok or $tipotok eq 'w') {
      $ref->{TIPOTOK}->{$func} = 'k';
      $tipo = 'k';
  } else {
      $tipo = lc($tipotok); 
  };  
  comfin('finv intentar_func_sin_blancos $tipo,$refarg',$tipo,'||',$func);
  return $tipo,[$func];
}#intentar_func_sin_blancos
#------------------------------------------------------------------------ 
sub intentar_simple{
  comfin('comv intentar_simple',@_);
  impr_debug(__LINE__.' Eva2 refglobal->{TIPOTOK}',$refglobal->{TIPOTOK});
  
  my ($ref,$expresionori) = @_; 
  impr_debug(__LINE__.' Eva2 $ref->{TIPOTOK}',$ref->{TIPOTOK});
  my ($coderr,$mensaje,$valorcito,$tipo,$tiparg,$refarg)
    = ('','','','','',[]); my ($pre,$post) = ('','');
  my $expresion = $expresionori;
  if ($expresion =~ s/^(\W*)([\.\d]+)(\W*)$/$2/ or
       $expresion =~ s/^(\W*)([\.\d]+[ED][\+\-]\d+)(\W*)$/$2/ or 
       $expresion =~ s/^(\W*)([\.\d]+[ED]\d+)(\W*)$/$2/) {      
      ($pre,$post) = ($1,$3);
      ($coderr,$mensaje,$valorcito,$tipo,$tiparg,$refarg)
         = evaluar_numero($expresion);
      impr_debug(__LINE__.' Eva2 $coderr,$mensaje',[$coderr,$mensaje]);
      $refarg = [$valorcito];
#      if ($coderr) {
#          mensajear($mensaje);
#      };
  } elsif ($expresion =~ s/^(\W*)(\w+)(\W*)$/$2/) {
      ($pre,$post) = ($1,$3);
      if ($expresion =~ /^\d/) {
          $mensaje = " $expresionori no representa un numero";
          if ($expresion =~ /O/) {
	      $mensaje .= "; hay una letra 0"; $coderr = 5;
          } else {
              $coderr = 1;
          };   
      } elsif (valor($ref,'TIPOTOK',$expresion) ) {
          my $tipotok = valor($ref,'TIPOTOK',$expresion);
          impr_debug(__LINE__.' Eva2 $tipotok',$tipotok);
          if ($tipotok =~ /([sS])/) {
              $tiparg = $tipotok;$refarg = [$expresion]; 
          } elsif (lc($tipotok) =~ /^[fgqt]$/ or 
                    $tiparg =~ /[-+*\/]$/) {
              $coderr = 9;$tiparg = lc($tipotok);$refarg = [$expresion];
          } else {
              $tiparg = $tipotok; $refarg = [$expresion];
          }
      } elsif ($expresion =~ /^[CDELMPR]$/i) {
          $tiparg = 'w'; $refarg = [$expresion];
          #podria resolverse despues 
      } else {
          $mensaje =" $expresion no puede representar nada";
          $coderr = 5;
      }; 
  } else {
      $coderr = 1;#no se ha podido tratar
  }; 
  if (not $coderr) {
      $tiparg = $pre.$tiparg.$post;
      $tiparg =~ s/\-n/o/g;
  } else {
      $tiparg = '0';$refarg = [$expresionori];
  };  
  comfin('finv intentar_simple',$coderr,$mensaje,$tiparg,'||',@$refarg);
  return $coderr,$mensaje,$tiparg,$refarg;     
}#intentar_simple  
# ---------------------------------------------------------------------------
sub intentar_token_sin_blancos{#aqui no llegan numeros
  comfin('comv intentar_token_sin_blancos', @_);
  my ($ref,$que,$valor) = @_; $valor = uc($valor); my $coderr = '';
  my $tipotok = valor($ref,'TIPOTOK',$valor);
  my ($tipo,$tiparg,$refarg) = ('','',[]);
  impr_debug(__LINE__.' Eva2 $valor,$tipotok',[$valor,$tipotok]);
  if (not $tipotok) {
      if ($valor !~ 
         /^[CDEJLMPQRT]/i and $que !~/^(PEDIDOS|TABLAS|FUNCIONES)$/ ) {
          $tiparg = 'X'; $refarg = [$valor];
      } else {
          $ref->{TIPOTOK}->{$valor} = 'w';
          $tiparg = 'w';$refarg = [$valor];
      };
  } else {
      if ($tipotok =~ /[adp]/) {
          impr_dat(__LINE__.' Eva2',$valor,$ref,'its');
          my ($nvalor,$ntipo,$ntiparg,$nrefarg) = tomar_cua_datos($ref,$valor);
          if ($ntipo =~ /[SWdnpsw]/) {
              $tiparg = $ntipo; $refarg = [$nvalor];
          } elsif ($ntipo eq 'o') {
              $tiparg = $ntipo; $refarg = [-$nvalor]; 
          } elsif ($ntipo =~ /[,xfgkqt]/) {
              $tiparg = $tipotok; $refarg = [$valor];
          } elsif ($ntipo eq '') {
              $tiparg = $tipotok; $refarg = [$valor];
          } else {    
             $coderr = 60;
          };
      } elsif  ($tipotok eq 'b') {
          my $rtipotok = valor($ref,'TIPOTOK',$valor);
          $tiparg = $rtipotok; $refarg = [$valor];  
      } elsif ($tipotok eq 'P') {
          $valor = $ref->{VALOR}->{$valor};
          $tiparg = $ref->{TIPOTOK}->{$valor};
          $refarg = [$valor];
      } elsif ($tipotok =~ /[fghkqtsWwS]/) {
          $tiparg = $tipotok; $refarg = [$valor];
      } else {
	   $tiparg = '9'; $refarg = [$valor];
      };
  };
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  comfin('finv intentar_token_sin_blancos',$tiparg,@$refarg);
  return $tiparg,$refarg;
}#intentar_token_sin_blancos
# ---------------------------------------------------------------------------
sub juntar_tipargs_refargs{#viene, quizas, entre parentesis; y algunos rectos
  comfin('comv juntar_tiparg_refarg',@_);
  my ($reftiparg,$refrefarg,$refsepas) = @_;
  if (not defined $refsepas) {
      @$refsepas = @$reftiparg;
      map($_ = '',@$refsepas); unshift @$refsepas,'';
  };
  impr_debug(__LINE__.' Eva2 $reftiparg',$reftiparg);
  impr_debug(__LINE__.' Eva2 $refrefarg',Dumper $refrefarg);
  impr_debug(__LINE__.' Eva2 $refsepas',$refsepas); 
  my ($tiparg,$refarg) = ($refsepas->[0],[]);my $coderr = '';
  for (my $ip = 0;$ip < @$reftiparg; $ip ++) {
      $tiparg .= $reftiparg->[$ip] . $refsepas->[$ip+1];
      push @$refarg,@{$refrefarg->[$ip]};
      impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  };
  $tiparg =~ tr/\[\]/()/;
  $tiparg =~  s/^\((.+)\)$/$1/; #seguro que son los agregados
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  $tiparg = simplificar_tiparg($tiparg);
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  comfin('finv juntar_tiparg_refarg');
  return $tiparg,$refarg;  
}#juntar_tipargs_refargs
# ---------------------------------------------------------------------------
sub limpiar_lista{#devuelve $coderr, $mensaje,$valor,$tiparg,$refarg
  comfin('comv limpiar_lista',@_);
  my ($ref,$que,$idcrear,$comando,$reflistaori) = @_;
  my ($coderr,$mensaje,$normal,$normaldes) = ('','','','');     
  my ($valor,$compltiparg,$tiparg,$refarg) = ('','','',[]);
  my $cuantos = @$reflistaori;
  my $reflista = [];
  @$reflista = @$reflistaori;  
  impr_debug(__LINE__.' Eva2 @$reflista',$reflista);
  my (@listipos, @refarg); 
  foreach my $parte (@$reflista) {
      my $parteori = $parte;
      my ($coderrn,$tipargcito,$refargcito,$normalcitodes)
         = desmembrar_expresion($ref,$que,$parte,'Eva2 '.__LINE__);
      if ($coderrn) {
          push @MENSAJES,$mensaje; $coderr = $coderrn;
      } elsif ($que eq 'TABLAS'  and $tipargcito =~ /[0sS]/) {
          $coderr = 70;
          push @MENSAJES,
            "No es aceptable $parte para definir una tabla";
      };
      if ($coderr) {# and last;
          comfin('finv limpiar_lista linea,$coderr,$valor,$tiparg,$refarg'
            ,__LINE__,$coderr);
          return $coderr;
      };
      my ($valorcito,$tipito);
      ($coderr,$valorcito,$tipito,$tipargcito,$refargcito)
       = tiparg_refarg_2_vttr_talcual($tipargcito,$refargcito,'Eva2 '.__LINE__);
      if (length $tipargcito != 1) {
          my($coderrc,$newpar,$nvalor,$ntipo,$ntiparg,$nrefarg,$tiposust)
             = crear_par_con_refarg(
              $ref,$idcrear,$valorcito,$tipito,$tipargcito,$refargcito);
          if ($coderrc eq '1') {#no fue necesario crear
              $tipargcito = $tipito = $tiposust; $
              $valorcito = $refargcito->[0];
              $tipargcito eq 'o' and $valorcito = - $valorcito; 
          } elsif ($coderrc) { 
              comfin('finv limpiar_lista linea $coderr'
                ,__LINE__,$coderrc);
              return $coderrc;
          } else {
              $valorcito = $newpar; $tipito = $tipargcito = $tiposust;
              $refargcito = [$valorcito];
	  };
      };
      impr_par(__LINE__.' Eva2', $tipargcito,$refargcito);
      $parte = $valorcito;
      push @listipos,$tipito; push @refarg,@$refargcito;
      (my $compl = $tipargcito) =~ s/[\Wno]//g;
      $compltiparg .= $compl;
  };#my $parte
  if (not $coderr) {
      $tiparg = join ',',@listipos; $refarg = \@refarg;
      if ($comando =~ /(COL|REP)/) {
          my $comi = $1;
          if ($tiparg =~ /o/) {
	      push @MENSAJES,
                " Valor negativo $valor no significa nada para $comi";
              $coderr = 70;
          };
          if (not $coderr and $comi eq 'REP') {
              (my $mensajet) = truncar_lista($tiparg,$refarg);
              if ($mensajet) {
                  $mensajet .= " para $comi";
                  push @MENSAJES,$mensajet;
              };
          }; 
      };
  };
  if (not $coderr) {
      my @refarg = @$refarg; $valor = '';
      foreach my $tipito (@listipos) {
          my $token = shift @refarg;
          $tipito eq 'o' and $token = -$token;
          push @{$ref->{REFLISTAVALOR}->{$comando}},$token;
          $valor .= ",$token";
      };
      $valor = substr($valor,1); 
      $ref->{COMPLTIPARG}->{$comando} = $compltiparg;
  };
  #$mensaje = join "\n     ",@lismensajes;
  impr_debug(__LINE__.' Eva2 REFLISTAVALOR->{$comando}'
    ,$ref->{REFLISTAVALOR}->{$comando});
  comfin('finv limpiar_lista linea,$coderr,$valor,$tiparg,$refarg'
    ,__LINE__,$coderr,$valor,$tiparg,$refarg);
  return $coderr,$valor,$tiparg,$refarg
 }#limpiar_lista; 
# ---------------------------------------------------------------------------
sub limpiar_valor{ # devuelve  $coderr,\@resultados,$granuni
  comfin('comv limpiar_valor',@_);
  my ($ref,$que,$normal) = @_;
  return (77,'palabra vacia') unless (defined $normal and $normal ne '');
  my ($coderr,$valor,$tipo,$func,$tipargdentro,$tiparg
    ,$refarg,$refargdentro) = ('','','','','','',[],[]);
  my @resultados;
  if (not $coderr) {
      my $nvalor ='';
      ($coderr,$tiparg,$refarg)
        = desmembrar_expresion($ref,$que,$normal,'Eva2 '.__LINE__);
      if ($coderr eq '9' or 
          not $coderr and $que eq 'PEDIDOS' and $tiparg =~ /w/) {
          $coderr = 9;
      };
  };
  if ($coderr) {
          comfin('finv limpiar_valor linea,$coderr',__LINE__,$coderr);
          return $coderr;   
  };
  impr_par(__LINE__.' Eva2 $tiparg,$refarg',$tiparg,$refarg);
  my $tiparge = $tiparg; my $refarge = []; @$refarge = @$refarg;# puede cambiar 
  impr_par(__LINE__.' Eva2 $tiparge,$refarge',$tiparge,$refarge);
  if (length $tiparge == 1) {
      $tipo = $tiparge;
#      if ($tiparg eq 'o') {
#              $valor = "-$refarg->[0]";
#      } else {
#              $valor = $refarg->[0];
#      };
#  } elsif ($tiparge =~ /^[fno\W\(\),]+$/) {
#      ($coderr,$tiparge,$refarge)
#	  = evaluar_tiparg_refarg_numerico($tiparge,$refarge);
#      if ($coderr) {
#          comfin('finv limpiar_valor linea,$coderr',__LINE__,$coderr);
#          return $coderr;   
#      } else {
#        $tipo = $tiparge;
#      };
#  } elsif ($tiparg =~ /^([fghkqt])\(([\w,]+)\)$/) {
#      $tipo = $1; $tipargdentro = $2;my @refarg = @$refarg;
#      $func = shift @refarg; @$refargdentro = @refarg;
#      error_progr(35,__LINE__.' Eva2');
  } else {
      $tipo = 'x';
  };
  $valor = tiparg_refarg_2_valor_talcual($tiparge,$refarge);
  impr_debug(__LINE__.' Eva2 $valor,$tipo,$tiparge,$refarge'
	     , [$valor,$tipo,$tiparge,'||',@$refarge]);

  if ($tipo eq 't') {
      if  (@{$refargdentro} == 1) {
          my $valordentro = $refargdentro->[0];
          $tipargdentro eq 'o' and $valordentro = -$valordentro; 
          $valor = "$func($valordentro)";
          if ($tipargdentro =~ /[no]/) {
              if ($ref->{TIPOTOK}->{$func} eq 'T') {
                  ($coderr,$valor,$tipo,$tiparge,$refarge)
                    = evaluar_t_n($ref,$func,$valordentro);
              } else {
                  push @{$ref->{pendientes}->{tq_n}},$normal;
              };
          };
      } else {
          $coderr = 30; 
          push @MENSAJES, " No se cumple argumento unico para tabla: $valor";
      }; 
  } elsif ($tipo eq 'q') {
      if ($tipargdentro =~ /^[n,o]+$/) {
          if ($ref->{TIPOTOK}->{$func} eq 'Q') {
              ($coderr,$valor,$tipo,$tiparge,$refarge)
                = evaluar_q_n($ref,$func,$tipargdentro,$refargdentro);
          } elsif ($ref->{TIPOTOK}->{func} ne '9') {
              push @{$ref->{pendientes}->{tq_n}},$normal;
          };
      };
  };
  $valor eq '' and
    $valor = tiparg_refarg_2_valor_talcual($tiparg,$refarg);
  # en  caso anterior $tiparg es = a $tiparge, @$refarge es igual a @$refarg
  if (length $tiparg == 1 and $tiparge !~ /[noSsw]/) {
      ($valor,$tipo,$tiparge,$refarge) = tomar_cua_datos($ref,$valor);
  };
  @resultados = ($valor,$tipo,$tiparge,$refarge);
  comfin('finv limpiar_valor linea,$coderr,\@resultados'
	 ,__LINE__,$coderr,'||',@resultados);
  return $coderr,\@resultados;   
}#limpiar_valor
# ---------------------------------------------------------------------------
sub mejorar_tiparg_refarg{
  comfin('comv mejorar_tiparg_refarg', @_);
  my ($que,$tiparg,$refarg) = @_;
# he sacado el $ref
  my ($coderr,$mensaje) = ('',''); my $refarge = [];@$refarge = @$refarg;
  if ($tiparg =~ /^\w\([no,]+\)$/) { 
  };
  if (not $coderr) {
      length ($tiparg) > 1 and  $tiparg = revisar_signos_tiparg($tiparg);
      if ($tiparg =~ /[\(,][no][-+no\*\/]+[,\)]/) {
          ($coderr,$tiparg,$refarge) = evaluar_paren_numer($tiparg,$refarg);
      };
  };
#  if (not $coderr) {
#      @$refarg = @$refarge;
#      ($tiparg =~/[no*\/]+[no]/ or $tiparg =~/[no][-+no]*[no]/) and 
#      ($coderr,$tiparg,$refarge) = simpl_terminos($tiparg,$refarg);
#  }; 
  comfin('finv mejorar_tiparg_refarg',$coderr,$tiparg,$refarge);
  return $coderr,$tiparg,$refarge;
}#mejorar_tiparg_refarg
# ---------------------------------------------------------------------------
sub mover_izq{
  comfin('comv mover_izq',@_);
  my($reftiparg,$refrefarg,$refsep,$refult,$ip) = @_;
  comfin('comv mover_izq',$ip);
  impr_detal_ip($ip-1,$reftiparg,$refrefarg,$refsep,$refult);
  impr_detal_ip($ip,$reftiparg,$refrefarg,$refsep,$refult);

  my ($tiparg,$refarg) = ($reftiparg->[$ip],$refrefarg->[$ip]);
  $reftiparg->[$ip-1] .= $tiparg;   
  push @{$refrefarg->[$ip-1]},@$refarg;
  $refult->[$ip-1] = $refult->[$ip];
  delete $refsep->[$ip]; delete $reftiparg->[$ip];  delete $refrefarg->[$ip];
  delete $refult->[$ip];
  @$reftiparg = grep (do {defined $_},@$reftiparg);
  @$refrefarg = grep (do {defined $_},@$refrefarg);
  @$refsep = grep (do {defined $_},@$refsep);   
  @$refult = grep (do {defined $_},@$refult);
  impr_detal_ip($ip-1,$reftiparg,$refrefarg,$refsep,$refult);
  $ip = $ip - 1;
  comfin('finv mover_izq',$ip);
  return $ip;
}#mover_izq
# ---------------------------------------------------------------------------
sub normalizar_expresion{
  comfin('comv normalizar_expresion', @_);
  #ya se sacaron unidades y se juntaron los h...
  # normaliza expresiones para las que sceptre o simusol admite varias formas
  # reduce a 1 espacios intermedios
  # viene sin espacios al comienzo y final;
  # antes y despues de cada separador
  # no detecta errores salvo:     avisa por XTABLE no usual
  #luego, los numeros no empezarán con '.' ni terminaran en .0..??
  my ($expresion,$ref) = @_; my ($coderr,$mensaje,$normal) = ('','','');
  if (not ($expresion =~ /^[\w\.\+\-\*\/\(\),\s\^]+$/)) {
      $coderr = 60;
      push @MENSAJES," Hay simbolos no esperados en $expresion";
      comfin('finv normalizar_expresion linea,$coderr'
       , __LINE__,$coderr);
      return $coderr;
  };   
  while (bien_cerrado($expresion)) { $expresion =~ s/^\((.*)\)$/$1/}; 
#  impr_debug(__LINE__.' Eva2 $_', $_); 
  my $cero = '0'; my $exprepar = "($expresion)";
  $exprepar =~ s/(\W)(\.\d)/$1$cero$2/g; 
  $_ = $exprepar;
#  impr_debug(__LINE__.' Eva2 $_',$_);
  $_ =~ s/^\((.*)\)$/$1/;
  s/^\s+//; s/\s+$//;
#  impr_debug(__LINE__.' Eva2 $_', $_); 
  while (s/^\+//) {};
  while (/[\+\-][\+\-]/) {# perl acepta, sceptre no.
        s/\+\+/+/;       s/\-\-/+/g;  # -- equivale a +
        s/\+\-/-/;       s/\-\+/-/g;  # -+ equivale a -
  }; # ++ y -- significan otra cosa en perl cuando siguen a una variable
  s/^\+//;
#  impr_debug(__LINE__.' Eva2 $_', $_); 
  my $sepa  = '[\s\(\)\+\-\*\/\^\,\=\']';  
#  my $sepanomasnomenos  = '[\s\(\)\*\/\^\,\=\']';  
  s/(\d)\.($sepa)/$1$2/g; #elimina puntos decimales finales;
  # lo que llega al Sceptre, Sceptre lo interpreta como real doble precision
  # aun si ni siquiera tenga punto decimal
#  impr_debug(__LINE__.' Eva2 $_', $_); 
  my $op = '[\+\-\*\/\^\(\)]';
#  s/\s+($sepanomasnomenos)/$1/g; 
#  s/($sepanomasnomenos)\s+/$1/g; # elimina espacios inútiles
#  #precaucion para no ocultar errores de escritura en not.cientifica:
  #los pegados a + o - recien despues de clasificar tokens
#  impr_debug(__LINE__.' Eva2 $_', $_); 
  s/([\(\,\*\/])\s*\+/$1/g; #elimina signos + inutiles
  $_ = '('.$_.')'; #para facilitar estudio; se sacan despues
  my $sepaesp = '[\(\)\+\-\*\/\,\=\'\s]';   
  impr_debug(__LINE__.' Eva2',$_);

  s/($sepa)TABL[EA]\s*(\w+)\s*\(/$1T$2\(/ig;
  s/($sepa)E[CQ]UA[TC]ION\s*(\w+)\s*\(/$1Q$2\(/ig;
  s/($sepa)EXPRES{1,2}ION\s*(\w+)\s*\(/$1X$2\(/ig;
  s/(\W)CALCULADO(\W)/$1SIMULADO$2/g;
  #no se espera CALCULADO.CALCULADO
  impr_debug(__LINE__.' Eva2',$_);
  s/XTABLE\((T\w+)\,/$1\(/g;
  #las posibles XTABLE las lleva a T
  #porque conviene evitar que el primer argumento de las XTABLE se interprete 
  #como variable y que los XTABLE parezcan indicadores de expresion
  #si quedan XTABLE ...
  /($sepa)XTABLE/ and  avnograv("Expresión con XTABLE no usual
                 $_;   Se interpreta como indicador de expresión");
  while (s/(\W)X\w+\(/$1\(/i) {}; #saca los X interiores; deja los ()
#  s/\^/**/g;
  $normal = $_;
  while (bien_cerrado($normal)) { $normal =~ s/^\((.*)\)$/$1/}; 
  my $normalpedido = $normal;
   $normal = "($normal)";
  while ($normal =~ s/(\W)time(\W)/$1TIEMPO$2/i) {}; 
  $normal =~ s/^\((.+)\)$/$1/;
  $normal = uc($normal);
  ($coderr,$normal,my $pendiente) = parentesis_bien_marcar($normal);
  if ($coderr) {
      push @MENSAJES, $coderr; 
#      comfin('finv normalizar_expresion linea,$coderr,$mens_desm'
#             ,__LINE__,$coderr,$mens_desm);
      $coderr = 30;
 #     return $coderr;
  };
  comfin('finv normalizar_expresion $coderr,$expresion,$normal'
   , $coderr,$expresion,$normal,$normalpedido);
  return $coderr,$expresion,$normal,$normalpedido;
}#normalizar_expresion
# ---------------------------------------------------------------------------
sub partir_refarg{#segun $parte0,$parte1,$parte2 de $tiparg
  comfin('comv partir_refarg',@_);
  my ($refarg,$parte0,$parte1,$parte2) = @_;
  my @arg =@$refarg;
  my ($tiparg0,$tiparg1,$tiparg2) = ($parte0,$parte1,$parte2);
  my ($refarg0,$refarg1,$refarg2) = ([],[],[]);
  impr_par(__LINE__.' Eva2',$tiparg0.$tiparg1.$tiparg2,$refarg);
  while  ($parte0=~ s/^(\W*)(\w)//) {
      push @$refarg0,shift @arg;
  };
  impr_par(__LINE__.' Eva2',$tiparg0,$refarg0);
  while  ($parte1 =~ s/^(\W*)(\w)//) {
       push @$refarg1,shift @arg;
  };
  impr_par(__LINE__.' Eva2',$tiparg1,$refarg1);
  while  ($parte2 =~ s/^(\W*)(\w)//) {
      push @$refarg2,shift @arg;
  };
  impr_par(__LINE__.' Eva2',$tiparg2,$refarg2);
  comfin('finv partir_refarg',@$refarg0,'||',@$refarg1,'||',@$refarg2);
  return $refarg0,$refarg1,$refarg2;
}#partir_refarg 
# ---------------------------------------------------------------------------
sub pegar5{
  comfin('comv pegar5',@_);
  my($tiparg0,$simb1,$tiparg11,$simb2,$tiparg2
     ,$refarg0,$refarg11,$refarg2,$abre,$cierra) = @_;
  my ($coderr,$tiparg,$refarg) = ('','',[]);
  impr_debug(__LINE__.' Eva2',[@$refarg0,'||',@$refarg11,'||',@$refarg2]);
  @$refarg = (@$refarg0,@$refarg11,@$refarg2);
  if ($tiparg11 =~ /^[no]/ and $simb1 eq '(' and $simb2 =~ s/^\)//) {
      if ($tiparg0 =~ s/([fgqt])$//) {
          my $func = pop @$refarg0;my $tipfunc = $1;
          my ($coderrn,my($tipargvalor,$refargvalor))
             = simpl_com_func($func,$tipfunc,$tiparg11,$refarg11);        
# le he sacado el $ref
          if (not $coderrn) {
              $tiparg = "$tiparg0$tipargvalor$simb2$tiparg2";
              @$refarg = (@$refarg0,@$refargvalor,@$refarg2);
          } else {
              $tiparg = "tiparg0$tipfunc$abre$tiparg11$cierra$tiparg2"
          };
      } else {
          $tiparg = "$tiparg0$simb1$tiparg11".')'."$simb2$tiparg2";
          @$refarg = (@$refarg0,@$refarg11,@$refarg2);
      };
      impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  } elsif (length $tiparg11 == 1) {   
      $tiparg = "$tiparg0$simb1$tiparg11$simb2$tiparg2";
      impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  } elsif ($tiparg11 =~ /^(\W*)(\w)(\W*)$/) {# una sola letra
      my ($pre11,$letra11,$post11) = ($1,$2,$3);
      my ($pre0,$letra0,$post0,$pre2,$letra2,$post2);  
      if ($tiparg0 =~ / ^(.*)(\w)(\W*)$/) {
          ($pre0,$letra0,$post0) = ($1,$2,$3); 
      } else {
          ($pre0,$letra0,$post0) =  ('','',$tiparg0);
      };    
      impr_debug(__LINE__.' Eva2 $pre0,$letra0,$post0',[$pre0,$letra0,$post0]);
      if ($tiparg2 =~ / ^(.*)(\w)(\W*)$/) {
          ($pre2,$letra2,$post2) = ($1,$2,$3); 
      } else {
          ($pre2,$letra2,$post2) =  ($tiparg2,'','');
      };
      impr_debug(__LINE__.' Eva2 $pre2,$letra2,$post2',[$pre2,$letra2,$post2]);
      if ("$post0$simb1" eq '(') {
          my $tipargprovi = "$letra0$post0$simb1$tiparg11$tiparg2";
          my $func = pop @$refarg0;
          my $refargprovi= [$func,@$refarg11,@$refarg2];
          impr_par(__LINE__.' Eva2',$tipargprovi,$refargprovi);
      }; 
      my $pretotal = "$post0$simb1$pre11"; $pretotal = pegarmasmenos($pretotal);
      my $posttotal="$post11$simb2$pre2";$posttotal = pegarmasmenos($posttotal);
      impr_debug(__LINE__.' Eva2 $pretotal,$posttotal',[$pretotal,$posttotal]);
      if ($posttotal eq '**') {# puede resultar en error
          $tiparg = 
            "$pre0$letra0$pretotal$abre$letra11$posttotal$letra2$cierra$post2";
      } else {
          $tiparg = 
             "$pre0$letra0$pretotal$letra11$posttotal$letra2$post2"
      };
      impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  };
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  $tiparg = simplificar_tiparg($tiparg) if length($tiparg) > 1; 
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  comfin('finv pegar5',$tiparg,'||',@$refarg);
  return $tiparg,$refarg
}#pegar5
# ---------------------------------------------------------------------------
sub pre_limpiar{#devuelve $coderr,$normal,$re,$granuni
    #$normalpedido,$tipotoknormal
  comfin('comv pre_limpiar',@_);
  my ($ref,$que,$datoori,$cosa) = @_;
  my ($coderr,$expre) = ('','');
  if (not $datoori) {
      push @MENSAJES, ' palabra vacia'; $coderr = 77;
      return $coderr;
  };
  ($coderr,$expre)
       = revisar_signos($ref,$datoori); #en pre_limpiar
  if ($coderr) {
      comfin('finv pre_limpiar linea,$coderr'
        ,__LINE__,$coderr);
      return $coderr;
  };
  my $granv = ";$expre;";
  if ($granv =~ /\W(\w+) (\w+)\W/) {
      ($coderr,my $valor)
          = Simusol::Prograf::interpretar_hconblanco($ref,$granv);
      #se ocupa de todas las posibles apariciones
      if (not $coderr) {
          $granv = $valor;
          ($expre = $granv) =~ s/;(.+);/$1/;
      } else {# no era una h-funcion}
          $coderr = '';
      }; 
  };
  my ($granvalor,$granuni) = ($expre,'');      
#  if ($que =~ /^(RESTOS|PPARAMETROS|DINICIALES|TIEMPOS)$/ ) {
   if ($que ne 'PEDIDOS' ) {
      ($coderr,$granvalor,$granuni) = separar_unidad($ref,$granvalor);
      if ($coderr) {
          comfin('finv pre_limpiar linea,$coderr',__LINE__,$coderr);
          return $coderr;
      };
  };
  my ($coderrn,$valor,$normal,$normaldes,$normalpedido)
     = normalizar_expresion($granvalor);
  if ($coderrn) {
      comfin('finv pre_limpiar linea,$coderr',__LINE__,$coderr);
      return $coderrn;
  };
  my $tipotoknormal = valor($ref,'TIPOTOK',$normal);
  my $tipo = valor($ref,'TIPO',$normal);
  my @resultados;
  impr_debug(__LINE__.' Eva2 $tipotoknormal,$tipo',[$tipotoknormal,$tipo]);
  if ($tipotoknormal and $tipotoknormal ne 'w') {
      if ($tipotoknormal =~ /[fghkqtm]/) {
          $que ne 'PEDIDOS' and 
          push @MENSAJES, " No es aceptable asignar $normal";
          $coderr = 9;
          comfin('finv pre_limpiar_valor linea,$coderr'
           ,__LINE__,$coderr);
          return $coderr;
      } elsif ($tipotoknormal =~ /[adPp]/ and $tipo ) {
          @resultados = tomar_cua_datos($ref,$normal);
      } else {
          @resultados = ($normal,$tipotoknormal,$tipotoknormal,[$normal]);
      };
      comfin('finv pre_limpiar linea,$coderr,$normal,@resultados'
        .',$granuni,$normalpedido'
            ,__LINE__,$coderr,$normal,'||',@resultados,'||',''
            ,$granuni,$normalpedido,$tipotoknormal);
          return $coderr,$normal,\@resultados,$granuni
             ,$normaldes,$normalpedido,$tipotoknormal;
  };
  my @lista = split ',',$normal;
#  ($coderr,@lista) = juntar_por_signos_y_paren(',',@lista);
  ($coderr,@lista) = juntar_por_paren_rec(',',@lista);
  my $refresultados = [];
  if ($coderr) {
      comfin('finv pre_limpiar_valor linea,$coderr,$mensaje'
        ,__LINE__,$coderr);
      return $coderr;
  };
  if (@lista >1 and $que eq 'PEDIDOS') {
      $coderr = 42;
  } elsif (@lista > 1) {
      my $idque = '';
      if ($que =~ /INICIALES/) {
          $idque = 'I';
      } elsif ($que eq 'DATOS') {
          $idque = 'D';
      } elsif ($que =~ /PARAMETROS/) {
          $idque = 'P';
      } elsif ($que =~ /TABLAS/) {
          $idque = 'Z';
      } elsif ($que =~ 'TIEMPOS') {
          $idque = 'Y';
      }; 
      ($coderr,my($valor,$tiparg,$refarg))
         = limpiar_lista($ref,$que,$idque,$cosa,\@lista);
           impr_debug(__LINE__.' Eva2 $valor,$tiparg,$refarg'
             ,Dumper [$valor,$tiparg,$refarg]);
      @resultados = ($valor,',',$tiparg,$refarg);
      impr_debug(__LINE__.' Eva2 @resultados',\@resultados);
  } else {
      ($coderr,my $refresultados) = limpiar_valor($ref,$que,$lista[0]);
      not $coderr and   @resultados = @$refresultados; 
  };
#  agregar_comentarios($ref,$cosa,$granvalor,'Eva2 '.__LINE__);
  comfin('finv pre_limpiar linea,$coderr,$normal,@resultados'
    .',$granuni,$normalpedido'
    ,__LINE__,$coderr,$normal,'||',@resultados,'||'
    ,$granuni,$normalpedido,$cosa);
  return $coderr,$normal,\@resultados,$granuni,$normaldes,$normalpedido;
}#pre_limpiar;
# ---------------------------------------------------------------------------
sub procesar{#devuelve $coderr,$refarg0,$refargcito,$refargresto,$tipargcito
  comfin('comv procesar',@_);
  my($refarg,$tiparg0,$pre,$tipargcito,$post,$resto) = @_; my $coderr = '';
  my($refarg0,$refargcito,$refargresto) 
    = partir_refarg($refarg,$tiparg0,"$pre$tipargcito$post",$resto);
  ($coderr,$tipargcito,$refargcito) 
     = evaluar_tiparg_refarg_numerico($tipargcito,$refargcito);
  $tipargcito = "$pre$tipargcito$post";
  $tipargcito =~ s/\(([no])\)/$1/; $tipargcito =~ s/\+\-/-/; 
  $tipargcito =~ s/\-o/n/;
  impr_par(__LINE__.' Eva2 0',$tiparg0,$refarg0);
  impr_par(__LINE__.' Eva2 cito',$tipargcito,$refargcito);
  impr_par(__LINE__.' Eva2 resto',$resto,$refargresto);
  comfin('finv procesar',$coderr,$refarg0,$refargcito,$refargresto,$tipargcito);
  return $coderr,$refarg0,$refargcito,$refargresto,$tipargcito;
}#procesar;
# ---------------------------------------------------------------------------
sub procesar_largo{#devuelve $coderr,$tiparg,$refarg
  comfin('comv procesar_largo',@_);
  my($tiparg,$refarg,$comi,$buscar,$final,$largo) = @_;
  my $coderr = '';
  while ($tiparg =~ /^(.*)($comi)($buscar)($final)(.*)$/ ) { 
      impr_debug(__LINE__.' Eva2 $1,$2,$3,$4,$5',Dumper [$1,$2,$3,$4,$5]);
      my $tiparg0 = $1; my $tipargcito = "$3"; my $resto = $5;
      my $pre = $2; my $post = $4;
      impr_debug(__LINE__.' Eva2 $tiparg0,$pre,$tipargcito,$post,$resto'
		 ,Dumper [$tiparg0,$pre,$tipargcito,$post,$resto]);
      if (length $tipargcito > $largo) {
          my($refarg0,$refargcito,$refargresto) 
            = partir_refarg($refarg,$tiparg0,"$pre$tipargcito$post",$resto);
          ($coderr,$tipargcito,$refargcito) 
            = evaluar_tiparg_refarg_numerico($tipargcito,$refargcito);
          if (not $coderr) {
              impr_par(__LINE__.' Eva2 0',$tiparg0,$refarg0);
              impr_par(__LINE__.' Eva2 cito',$tipargcito,$refargcito);
              impr_par(__LINE__.' Eva2 resto',$resto,$refargresto);
              $tipargcito = "$pre$tipargcito$post";
              impr_debug(__LINE__.' Eva2 $tipargcito',$tipargcito); 
              $tipargcito =~ s/\(([no])\)/$1/; $tipargcito =~ s/\+\-/-/; 
              $tipargcito =~ s/\-o/n/;$tipargcito =~ s/\+o/-n/;
              impr_debug(__LINE__.' Eva2 $tipargcito',$tipargcito); 
              $tiparg = $tiparg0 . $tipargcito .$resto;
              push @$refarg0,@$refargcito,@$refargresto;
              @$refarg = @$refarg0;
          } else {
               comfin('finv evaluar_terms $coderr linea ',__LINE__,$coderr);
               return $coderr;
          }; 
      } else {
          $tiparg = "$tiparg0$pre;$tipargcito$post$resto";
      };
      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);   
  };#while
  $tiparg =~ s/;//g;
  $tiparg =~ s/^\-n/o/;# por si se ha usado el + inicial
  impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);   
  comfin('finv procesar_largo',$coderr,$tiparg,'||',@$refarg);
  return $coderr,$tiparg,$refarg;
}#procesar_largo;
# ---------------------------------------------------------------------------
sub revisar_funcion{#return $coderr,$tipargt,$refargt
  comfin('comv revisar_funcion',@_);
  #$tipargtodo viene sin el ] y posibles otros ] y comas finales
  my ($ref,$tipargtodo,$refargtodo,$itpost) = @_; my $coderr = '';
  impr_par(__LINE__.' Eva2 todo antes ',$tipargtodo,$refargtodo);
  my $buscar = '[^\[]+';
  $tipargtodo =~ /^(.*)(\w)\[($buscar)$/; 
  impr_debug(__LINE__.' Eva2 $1,$2,$3',[$1,$2,$3]);
#  my $resto = ''; $4 and $resto = $4;
  my ($comi,$tipofunc,$tipargdentro) = ($1,$2,$3);
  my($comirefarg,$refargdentro)
    = separar_refarg($tipargtodo,$refargtodo,$tipargdentro);
  my $func = pop @$comirefarg;
  impr_par(__LINE__.' Eva2 dentro',$tipargdentro,$refargdentro);
  my($valor,$tipo,$tipargf,$refargf,$tipargff,$refargff,$tiposust,$newpar,$regarff);
  impr_par(__LINE__.' Eva2 funcion',$tipofunc,[$func]);
  if ($tipargdentro =~ /^[-+\*\/no]+$/ and length($tipargdentro) > 1) { 
      ($coderr,$tipargdentro,$refargdentro)
	  = evaluar_tiparg_refarg_numerico($tipargdentro,$refargdentro);
      if ($coderr) { 
          comfin('finv revisar_funcion linea $coderr',__LINE__.' Eva2',$coderr);
          return $coderr;
      };
  };
  if ($tipargdentro =~ /^[no,]+$/) {
     if ($tipofunc =~ /[ft]/) {
          if (length($tipargdentro) == 1) { 
              my $absc = $refargdentro->[0];
              $absc = -$absc if $tipargdentro eq 'o';
              impr_debug(__LINE__.' Eva2 $absc',$absc);
              ($coderr,$valor,$tipo,$tipargf,$refargf)
                 = evaluar_funcion($ref,$func,$tipofunc,$absc);
          } else {
              push @MENSAJES," No es posible evaluar $func con esos argumentos";
             $coderr = 36;
          };  
      } elsif ($tipofunc eq 'q') {
          ($coderr,$tipargf,$refargf)
	      = evaluar_q_n($ref,$func,$tipargdentro,$refargdentro);
      } elsif ($tipofunc eq 'g') {
          ($coderr,$valor,$tipo,$tipargf,$refargf)
              = evaluar_g_n($func,$tipargdentro,$refargdentro);
      };
  } else {
       ($coderr,$newpar,$valor,$tipo,$tipargff,$refargff,$tiposust)
          = crear_par_con_refarg(
       $ref,'A','','',$tipofunc.'['.$tipargdentro.']',[$func,@$refargdentro]);
       $tipargf = $tiposust; $refargf = [$newpar];
  };
  $itpost =~ s/^\[//;
  if ($itpost) {
      if ($comi =~ /^(.*,)([^,\[]+)$/) {
          impr_debug(__LINE__.' Eva2 $itpost, $comi,$1,$2'
            ,[$itpost,$comi,'||',$1,'||',,$2]);
          my ($uno,$dos) = separar_refarg($comi,$comirefarg,$2);
          my $tipargtramo = "$2.$tipargf"; my $refargtramo = [];
          @$refargtramo = @$dos;
          push @$refargtramo,$refargf;
          impr_par(__LINE__.' Eva2 tramo',$tipargtramo,$refargtramo); 
      };
  };
  if(not $coderr) {
      impr_debug(__LINE__.' Eva2 $comi $tipargf',[$comi,$tipargf]);
      $tipargtodo = "$comi$tipargf"; push @$comirefarg,@$refargf;
      @$refargtodo = @$comirefarg;
  };
  impr_par(__LINE__.' Eva2 todo despues',$tipargtodo,$refargtodo);
  comfin('finv revisar_funcion',$coderr,$tipargtodo,$refargtodo);
  return $coderr,$tipargtodo,$refargtodo;
}#revisar_funcion
# ---------------------------------------------------------------------------
sub revisar_signos{#return $coderr,$mensaje,$expresion
  # elimina espacios innecesarios y dobles parentesis y detecta errores
  comfin('comv revisar_signos',@_);
  my ($ref,$expresionori) = @_; my ($coderr,$expresion) = ('','','');
  $_ = $expresionori;
  s/\s+/ /g;
  if ( /\,$/) { 
      push @MENSAJES," En  $expresionori hay coma final extra o faltan datos";
      $coderr = 22;
  };
  s/\*\*/\^/g; #para tener operadores de un solo símbolo; se mantendra hasta 
  # eval o imprimir en .d o .par o .paraplot 
  if ($expresionori =~ /[-*\/^]$/) {
      push @MENSAJES," En $expresionori hay signo final extra";
      $coderr = 23;
  };  
  my @listavalores = split '\s*,\s*';
  ($coderr, @listavalores) = juntar_por_paren_cur(',',@listavalores); 
  if ($coderr) {
       push @MENSAJES, " Sobran o faltan parentesis en \"$expresionori\""; 
       $coderr = 24;
  };
  my @malos = grep(do{$_ eq ''},@listavalores);
  if (@malos) {
      push @MENSAJES, " En $expresionori hay coma al principio o repetidas";
      $coderr = 25;
  };
  if ($coderr) {
     comfin('finv revisar_signos linea $coderr',__LINE__,$coderr);
      return $coderr;
  };
  if (/^(\-{0,1})\s*([\w\.]+)$/) {
      $expresion = "$1$2";
      my $reflista = [$_];
      comfin('finv revisar_signos linea,$coderr,$expresion,$reflista'
           ,__LINE__,$coderr,$expresion,'||',@$reflista);
       return $coderr,$expresion,1,$reflista ;
  };
  # para notacion cientifica 6E+55 en perl no se aceptan espacios intercalados
  my $sepanomasnomenos  = '[\s\(\)\*\/\^\,\=\']';  
  s/($sepanomasnomenos)\s+/$1/g; s/\s+($sepanomasnomenos)/$1/g;
           #con + y - no, para no ocultar errores
#  impr_debug(__LINE__.' Eva2 $_',$_);
  s/([\+\-])\s+([A-Za-z])/$1$2/;
  while (s/([^DE])\s([+-])/$1$2/) {};
  while (s/([^DE])([+-])\s/$1$2/) {};
  while (s/([DE])([+-])\s(\D)/$1$2$3/) {};
  $expresion = $_;
  $_ = $expresion;  # parentesis_bien usa $_         
  if (not $coderr and /[\+\-\*\/\^\,\(]\s*$/) {
      push @MENSAJES, " \"$expresionori\" no termina bien";
      $coderr = 9; # si se pidio para PEDIDOS  ...
  }; 
  if (not $coderr and /^\s*[\*\/\^\,\)]/) {
      push @MENSAJES, " \"$expresionori\" no empieza bien";
      $coderr = 66;
  };
  impr_debug(__LINE__.' Eva2 $_',$_);
  if (not $coderr and $_ !~ /^([\w\.\s\,\(\)\+\-\*\/\^]+)$/) {
      push @MENSAJES
        ,"  \"$expresionori\" con símbolos no válidos para un valor";
      $coderr = 66;  
  };
  #los siguientes no se ponen las g porque con detectar uno alcanza
  if (not $coderr and  /([\+\-\*\/\^\(\,])\s*([\*\/\^\)\,])/) { 
  # aunque perl y fortran entienden el - pegado; sceptre  no lo acepta 
      my ($pri,$seg) = ($1,$2); 
#      $pri =~ s/\^/**/; $seg =~ s/\^/**/; 
      if ($pri eq '(' and $seg eq ')') {
         #puede ser una funcion sin argumentos
      } else {
          push @MENSAJES
            ," \"$expresionori\"; Hay operadores pegados inadmisibles
             $pri $seg";
          $coderr = 66;
      };
  };
  if (not $coderr and /\+\+/ or /\-\-/) {
      push @MENSAJES
        , " \"$expresionori\": ni Simusol ni Sceptre utilizan ++ o --";
      $coderr = 66;
  };
  if (not $coderr and /([\*\/\^])\s*(\-)/) {
      my ($pri,$seg) = ($1,$2);
      push @MENSAJES, " \"$expresionori\": Sceptre no acepta que 
          el \"-\" siga a otro operador
            $pri $seg;    use parétesis";
      $coderr = 66;
  };
  if (not $coderr and /\D\.\D/ or /^\.\D/ or /\D\.$/) {
     push @MENSAJES, " \"$expresionori\":  tiene  \".\" suelto";
     $coderr = 66;
  }; 
  if ($coderr) {
      comfin('finv revisar_signos',$coderr,$expresion); 
      return $coderr,$expresion;
  };
#  s/\^/**/g; se mantiene hasta eval o imprimir en .d o .par o .paraplot
#  ($coderr, @listavalores) = juntar_por_paren_cur(','
#           ,(split '\s*,\s*'));
#  my $cuantos = scalar @listavalores;
  $expresion = $_;
  comfin('finv revisar_signos linea $coderr,$expresion'
       ,__LINE__,$coderr,$expresion);
  return $coderr,$expresion;
}#revisar_signos
# ---------------------------------------------------------------------------
sub revisar_signos_tiparg{
  comfin('comv revisar_signos_tiparg',@_);
  my $tiparg = ";$_[0]"; $tiparg =~ s/;\-n/;o/;
  $tiparg =~ s/\s+//;
  while ($tiparg =~ s/\((\([^\(\)]+\))\)/$1/){};
  while ($tiparg =~ /^(.*)(\S)\(([no])\)(.*)/) {
#      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
      my ($antes,$pre,$dentro,$despues) = ($1,$2,$3,$4);
      if ($pre =~ /[\(\+\-]/ and $dentro =~ /[no]/) {
          $tiparg  = "$antes$pre$dentro$despues";
      } else {
         $tiparg = "$antes$pre".'['.$dentro.']'.$despues;  
      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
      };
  };
  $tiparg =~ tr/[\[\]]/()/;
  while ($tiparg =~ s/([\+\-\*\/])\(n\)/$1n/) {};
  impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  while ($tiparg =~ s/([\+\-\*\/])\(\-n\)/$1o/) {};
      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  while ($tiparg =~ s/^((\w)\-\(n\))/$1-n/) {};
      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  while ($tiparg =~ s/(\+)\(-n\)/-n/) {};
      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  while ($tiparg =~ s/(\-)\(-n\)/+n/) {};
      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  while ($tiparg =~ s/(\w[\(,])-n([\),])/$1o$2/) {};
      impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  $tiparg =~ s/^\;//;  
  comfin('finv revisar_signos_tiparg',$tiparg);
  return $tiparg;
}#revisar_signos_tiparg
# ---------------------------------------------------------------------------
sub separar_refarg{# devuelve $comirefarg,$parterefarg
# $partetiparg viene al final de $tipargtodo
  comfin('comv separar_refarg',@_);
  my ($tipargtodo,$refargtodo,$partetiparg) = @_;
  my ($comirefarg,$parterefarg) = ([],[]);
  (my $esqueletras = $partetiparg) =~ s/\w+//g;
  while ($esqueletras) {
      unshift @$parterefarg,pop @$refargtodo;
      $esqueletras =~ s/^.//;
  };
  @$comirefarg = @$refargtodo;
  comfin('finv separar_refarg',$comirefarg,$parterefarg);
  return $comirefarg,$parterefarg;
}#separar_refarg
# ---------------------------------------------------------------------------
sub separar_unidad{# devuelve $coderr,$granvalor,$granuni
  #aun no ha sido normalizado; espacios de a 1?
  #no hay espacios al final ni al principio
  # en las unidades no hay parentesis ni mas ni menos ni otros signos raros
  # pero puede haber * /; y empiezan con letra no digito
  # cuidado 5E7 podria interpretarse como numero 5 y unidad E7 pero preferimos
  # numero 5E7; preferible usar espacio antes de la unidad
  #  o valor entre parentesis
  comfin('comv separar_unidad',@_);
  my ($ref,$granvalorori) = @_;
  my $parauni = '[A-Za-z][\w\*\/]*'; # * en lugar de + porque ya hay una letra
#  impr_debug(__LINE__.' Eva2 $granvalor', $granvalor);
  my @listaval = split /\s*,\s*/,$granvalorori; 
  impr_debug(__LINE__.' Eva2 @listaval', \@listaval);
  my (@listunis,$granuni);
  my ($granvalor,$coderr) = ('','');
  foreach my $valor (@listaval) {
      my $parvalor = '('.$valor;
      my ($ya,$uni) = ('','');
      my $leftvalor;
      if ($valor =~ /^(.*[\w\)])\s($parauni)$/) {
          #impr_debug(__LINE__.' Eva2',[$1,$2]);
          $leftvalor = $1; $uni = $2; $ya = 1;
           impr_debug(__LINE__.' Eva2 sospecha $ya,$leftvalor,$uni'
                    ,[$ya,$leftvalor,$uni]);
      } elsif ($valor =~ /^(.+\))($parauni)$/) {
          #impr_debug(__LINE__.' Eva2',[$1,$2]);
          $leftvalor = $1; $uni = $2; $ya = 1;
          impr_debug(__LINE__.' Eva2 sospecha $ya,$leftvalor,$uni'
                    ,[$ya,$leftvalor,$uni]);
      } elsif (
          $parvalor =~ /^(.*)(\W)(\d*\.{0,1})(\d+)([DE][\+\-]{0,1}\d+\W*)$/){
          #impr_debug(__LINE__.' Eva2 $1,$2,$3,$4,$5',[$1,$2,$3,$4,$5,$6]);
          $leftvalor = "$1$2$3$4$5"; $uni = ''; $ya = 1;
          impr_debug(__LINE__.' Eva2 $parvalor',$parvalor);
          impr_debug(__LINE__.' Eva2 $leftvalor',$leftvalor);
          $leftvalor =~ s/^\(//;
          impr_debug(__LINE__.' Eva2 $leftvalor',$leftvalor);
          impr_debug(__LINE__.' Eva2 sospecha $ya,$leftvalor,$uni'
            ,[$ya,$leftvalor,$uni]);
      } elsif ($parvalor =~ /^(.*)(\W)(\d*\.{0,1})(\d+)($parauni)$/) { 
           #impr_debug(__LINE__.' Eva2 $1,$2,$3,$4,$5',[$1,$2,$3,$4,$5]);
           $leftvalor = "$1$2$3$4"; $uni = $5; $ya = 1;
           $leftvalor =~ s/^\(//;
           impr_debug(__LINE__.' Eva2 sospecha $ya,$leftvalor,$uni'
               ,[$ya,$leftvalor,$uni]);
      };           
      push @listunis, $uni;
      if ($ya) {
          $valor = $leftvalor;
      };
      impr_debug(__LINE__.' Eva2 $valor,$uni',[$valor,$uni]);
      $granvalor .= $valor.','
  };
  @listunis = union_conjunto(@listunis);
  @listunis = grep ($_,@listunis);
  $granuni = $listunis[0];
  if (@listunis >1) {
      mensajear("Aparecen unidades distintas en\n    $granvalorori");
      $coderr = 55;
      comfin('finv separar_unidad linea, $coderr',__LINE__,$coderr);
      return $coderr;
  };    
  $granvalor =~ s/\,$//;
  comfin('finv separar_unidad, linea,$coderr,$granvalor,$granuni'
    ,__LINE__,$coderr,$granvalor,$granuni);
  return $coderr,$granvalor,$granuni;
}#separar_unidad
sub simpl_paren_o{
  comfin('comv simpl_paren_o',@_);
  my $tiparg = $_[0];
  $tiparg =~ tr /[\[\]]/()/;
  impr_debug(__LINE__.' Eva2 $tiparg',$tiparg);
  while($tiparg =~ /^(.*)(.)\(\-n\)(.*)$/) {
      my ($antes,$pre,$despues) = ($1,$2,$3);my $centro;
      if ($despues =~ /^\*\*/) {
          $centro = '[-n]';
      } else {  
          impr_debug(__LINE__.' Eva2 $antes,$pre,$despues'
		 ,[$antes,$pre,$despues]);
          $pre eq '+' and $centro = '-n' or
          $pre eq '-' and $centro = 'n' or
          $pre =~ /[\*\/]/ and $centro = '[-n]' or
          $pre eq '(' and $centro = '-n';
      };
      $tiparg = "$antes$pre$centro$despues";
  };
  $tiparg =~ tr/][/)(/;
  comfin('finv simpl_paren_o',$tiparg);
  return $tiparg;
}#simpl_paren_o
# ----------------------------------------------------------------------------
sub evaluar_tiparg_refarg_numerico{#devuelve $coderr,$tiparg,$refarg
  comfin('comv evaluar_tiparg_refarg_numerico',@_); #unicas letras del tiparg nof
  my ($tiparg,$refarg)= @_; my $coderr = '';
  my $valor = tiparg_refarg_2_valor_talcual($tiparg,$refarg,'Eva2 '.__LINE__);
  $valor =~ s/\^/**/g; $valor =~ tr/[]/()/;
  impr_debug(__LINE__.' Eva2 $valor a calcular',$valor);
  use warnings  FATAL => qw(syntax void);
  my $valorc = eval(lc($valor));
  ($@ or not defined $valorc) and do {
      push @MENSAJES,
        "$@; No se puede calcular $valor; no representa  un número";
      $coderr = 66;
      comfin('finv evaluar_tiparg_refarg_numerico',$coderr);
      return $coderr;
  };
  $tiparg = 'n'; $valorc < 0 and $tiparg = 'o'; $refarg = [abs($valorc)];
  impr_par(__LINE__.' Eva2',$tiparg,$refarg); 
  comfin('finv evaluar_tiparg_refarg_numerico',$coderr,$tiparg,'||',@$refarg);
  return $coderr,$tiparg,$refarg 
}#evaluar_tiparg_refarg_numerico
# ---------------------------------------------------------------------------
sub simplificar_tiparg{ #devuelve $tiparg 
  comfin('comv simplificar_tiparg',@_);
  my $tiparg = $_[0];
  $tiparg =~ s/^\-n/o/; $tiparg =~ s/([\(,])\-n/$1o/g;
  $tiparg =~ s/\-\-/+/g; $tiparg =~ s/\+\-/-/g;
 # impr_debug(__LINE__.' Eva2',$tiparg);
 # impr_debug(__LINE__.' Eva2',$tiparg);
  $tiparg =~ s/\(\-n\)/(o)/g; $tiparg =~ s/(\W)\(n\)/$1n/; 
  impr_debug(__LINE__.' Eva2',$tiparg);
  $tiparg =~ s/^\(\(([^\(\)]+)\)\)/($1)/; #dobles parentesis
  while ($tiparg =~ s/\(\(([o])\)\)/($1)/g) {};
  while ($tiparg =~ s/\(([adnp])\)/$1/g) {};
  $tiparg .=';';
  while ($tiparg =~ /^(.*)([-+*\/\(\)])\(o\)(\W)(.*)$/ and $3 ne '^') {
      impr_debug(__LINE__.' Eva2 $3',$3);
      $tiparg = $1.$2.'o'.$3.$4;
#      $tiparg =~ s/\+\-/-/;$tiparg =~ s/\-\-/+/; 
  };
  impr_debug(__LINE__.' Eva2',$tiparg);
  $tiparg =~ s/;$//;
  $tiparg =~ s/\-\+/-/g; $tiparg =~ s/\+\-/-/;
  $tiparg =~ s/\+\+/+/g; $tiparg =~ s/\-\-/+/;
  impr_debug(__LINE__.' Eva2',$tiparg);
  return $tiparg if length $tiparg < 3;
      
  impr_debug(__LINE__.' Eva2',$tiparg);
###  $tiparg =~ s/(\w)\+o/$1-n/g; $tiparg =~ s/(\w)\-o/$1+n/g; 
  impr_debug(__LINE__.' Eva2',$tiparg);
###  $tiparg =~ s/(\w)\+o/$1-n/g; $tiparg =~ s/(\w)\-o/$1+n/g; 
  while ("$tiparg;" =~ /^(.*)([-+*\/\(\)])\(o\)(\W)(.*)$/ and $3 ne '^') {
      impr_debug(__LINE__.' Eva2 $3',$3);
      $tiparg = $1.$2.'o'.$3.$4;
      impr_debug(__LINE__.' Eva2',$tiparg);
      $tiparg =~ s/\+\-/-/;$tiparg =~ s/\-\-/+/; 
 };
  impr_debug(__LINE__.' Eva2',$tiparg);
  #$tiparg =~s/^;\+(\w)/;$1/;
#  impr_debug(__LINE__.' Eva2',$tiparg);
 # $tiparg =~ s/\^/**/g;
 # $tiparg =~ s/;(.+)/$1/; $tiparg =~ s/;$//;
  comfin('finv simplificar_tiparg',$tiparg);
  return $tiparg;
}#simplificar_tiparg
1
__END__
# ---------------------------------------------------------------------------
sub truncar_lista{
  comfin('comv truncar_lista',@_);
  my ($tiparg,$refarg) = @_; my @lismensajes;
  my $tipargori = $tiparg;my @refarg;
  while ($tiparg =~ s/^(\W*)(\w)/$1/) {
      my $token = shift @$refarg;
      if ($2 eq 'n') {
          push (@refarg,int ($token));
          push @lismensajes," Cambie $token por int($token)"
      } else {
          push(@refarg,$token);
      };
      impr_debug(__LINE__.' Eva2', Dumper \@refarg);
  };
  @$refarg = @refarg;
  my $mensaje = join ";   ",@lismensajes;  
  comfin('finv truncar_lista',$mensaje);
  return $mensaje;
}#truncar_lista;
# ---------------------------------------------------------------------------
sub vttr{#devuelve $coderr,$mensaje,$valor,$tipo,$tiparg,$refarg
  comfin('comv vttr',@_);
  my $valorori = $_[0];
  my ($coderr,$mensaje,$valor,$tipo,$tiparg,$refarg) = ('','','','','',[]); 
  use warnings  FATAL => qw(syntax void);
  $valor = eval(lc($valorori));
  if ($@ or not defined $valor) {
      $coderr = 33;
      $mensaje = "No se puede calcular $valorori;";
      if ($valorori =~ /O/) {
          $mensaje .= " hay una letra O";
      } else {
          $mensaje .= " no es un numero";
      };
  } else {
      $refarg = [$valor];
      $tipo = 'n'; $valor < 0 and $tipo = 'o'; 
      $tiparg = $tipo;  
  };
  comfin('finv vttr $coderr,$mensaje,$valor,$tipo,$tiparg,@$refarg'
	 ,$coderr,$mensaje,$valor,$tipo,$tiparg,'||',@$refarg);
  return $coderr,$mensaje,$valor,$tipo,$tiparg,$refarg;
}
# ---------------------------------------------------------------------------
sub tiparg_refarg_2_lisargus{#devuelve $coderr,$tipargtotal,$refargtotal
  #los argumentos son siempre simples
  comfin('comv tiparg_refarg_2_lisargus',@_);
  my ($func,$tiparg, $refarg)= @_;  my $coderr= '';my @refarg = @$refarg;
  my ($ope,$argnum) = ('*',1);
  $func eq 'QSUMA' and do{$ope = '+',$argnum = 0};
  impr_par(__LINE__.' Eva2',$tiparg,$refarg);
  my @listiparg = split ',',$tiparg;
  my @lisargusnonum; my($tipargnonum,$tipargnum) = ('','');
  for( my $i = 0; $i < @listiparg; $i++) {
      if ($listiparg[$i] eq 'n') {
         $argnum = eval "$argnum $ope $refarg[$i]";
      } elsif ($listiparg[$i] eq 'o') {
         $argnum = eval "$argnum $ope -$refarg[$i]";
      } else {
         push @lisargusnonum,$refarg[$i];
         $tipargnonum .= $listiparg[$i].','; 
      };
      impr_debug(__LINE__.' Eva2 $argnum',$argnum);
  };
  $tipargnonum =~ s/,$//;
  impr_debug(__LINE__.' Eva2 $tipargnonum,@lisargusnonum'
    ,[$tipargnonum,'||',@lisargusnonum]);
  $argnum >= 0 and $tipargnum = 'n' or $tipargnum = 'o';
  impr_debug(__LINE__.' Eva2 $tipargnum,$argnum',[$tipargnum,$argnum]);
  my $tipargtotal = ''; my @refargtotal;
  if (@lisargusnonum == 0) {
      $tipargtotal = $tipargnum; push @refargtotal,abs($argnum);
          impr_par(__LINE__.' Eva2',$tipargtotal,\@refargtotal); 
  } elsif ($ope eq '*' and $argnum == 0) {
          $tipargtotal = 'n'; @refargtotal = (0);
          impr_par(__LINE__.' Eva2',$tipargtotal,\@refargtotal); 
  } elsif (@lisargusnonum == 1) {
      if (($ope eq '*' and $argnum == 1) or
          ($ope eq '+' and $argnum == 0)) {
          $tipargtotal = $tipargnonum;
          @refargtotal = @lisargusnonum;
          impr_par(__LINE__.' Eva2',$tipargtotal,\@refargtotal); 
     } elsif ($ope eq '*' and $argnum == -1) {
          $tipargtotal = "-$tipargnonum";
          @refargtotal = @lisargusnonum;
          impr_par(__LINE__.' Eva2',$tipargtotal,\@refargtotal); 
      } else {
          $tipargtotal = 'g('.$tipargnum.','.$tipargnonum.')';
          @refargtotal = ($func,abs($argnum),@lisargusnonum);
          impr_par(__LINE__.' Eva2',$tipargtotal,\@refargtotal); 
     };
  } else {
      $tipargtotal = 'g('.$tipargnum.','.$tipargnonum.')';
      @refargtotal = ($func,abs($argnum),@lisargusnonum);
  };   
  comfin('finv tiparg_refarg_2_lisargus $coderr $tipargtotal,@refargtotal'
    ,$coderr,$tipargtotal,@refargtotal);
  return $coderr,$tipargtotal,\@refargtotal;
}
1
