CSECT SCEPTRE2
C     REVISED 6/4/73 
cloli modified exec2.f
cloli declaration of common /tapes/ moved to tapes2.inc; values,here 
cloli LIBTP,IX and IUT1 are not used; ltotal will not be used
cloli changed comparisons

      PROGRAM      S C E P T R E 2 
 
C S C E P T R E, Copyright 1990-2003 by WRNovender, all rights reserved

C      SCEPTRE SOLUTION CONTROL EXECUTIVE ROUTINE. 

      IMPLICIT DOUBLE PRECISION (A-H,O-Z), INTEGER (I-N)
      include 'tapes2.inc'
      PARAMETER(ZERO=0.D0)

cloli COMMON /TAPES/  NOUTTP,INTAPE,LIBTP,INOUTP,NEDITP,NSAVTP,
cloli*                IP,IX,IUT1,npunch,nactpe,iqqtmp,imonte
cloli  moved to tapes2.inc; 
cloli (modified: npunch,nactape,iqqtmp,imonte go to 9-th to 12-th places) 

      COMMON /CNTRLS/ CTROLS(160) 
         EQUIVALENCE (XTMON,CTROLS(36)) 
         EQUIVALENCE (XMCPUT,CTROLS(40)),(XMXSLT,CTROLS(37)) 
      COMMON /SAVERN/ KRAND 

C     THESE COMMONS REQUIRED  TO PREVENT LINK EDIT ERROR*** 

      COMMON /NAMES/  ZNAM 
      COMMON /VOLTGS/ ZVOLT 
      COMMON /CURNTS/ ZCURN 
      COMMON /SAVEIC/ ZSAVIC 
      COMMON /SAVICT/ ZSVICT 
      COMMON /DERIVS/ ZDERIV 
      COMMON /ELNAMS/ ZELNAM 
      COMMON /EBACK/  ZEBAC 
      COMMON /PBACK/  ZPBAC 
      COMMON /ELIMIT/ ZELIM 
      COMMON /PLIMIT/ ZPLIMT 
      COMMON /OSTATS/ ZOSTT 
      COMMON /OPTEMP/ ZOPTM 
      COMMON /SAVEDC/ ZSVDC 
      COMMON /GVALUE/ ZGVAL 
      COMMON /YVALUE/ ZYVAL 
      COMMON /PRMTRS/ ZPRM 
      COMMON /DPNAMS/ ZDPNMS 
      COMMON /OUTPUT/ ZOUTPT
      logical ldirac,lpost
      data    ldirac /.false./
         

      KRAND = 0
      INOUTP=10
      IQQIP4= 4 
      NEDITP= 3 
      INTAPE= 5 
      NOUTTP=16 
      NSAVTP= 8 
      npch=  18
      nactp =11
      iqqtmp=13
      imonte=20
      NLIBTP=21
      ISIM=   7
c     en setdat.f  LIBTP would be real*8
c     open input and output files; or stop      
      call open2 
C IBM:
C     THIS ELIMINATES TERMINATION BECAUSE OF UNDERFLOW AND ALIGNMENT 
C     ERRORS. 
C       CALL ERRSET(208,300,-1,2)
C       CALL ERRSET(210,300,10,2)
C     AN OVERFLOW OR DIVIDE CHECK ERROR CAN OCCUR WITHOUT BEING 
C     TERMINATED BY THE OPERATING SYSTEM. 
C       CALL ERRSET(207,300,10,2)
C       CALL ERRSET(209,300,10,2)
C     THIS CALL TO ERRSET ELIMINATES TERMINATION BECAUSE AN 
C     EXPONENT IS GREATER THAN 174.D0. 
C       CALL ERRSET(262,300,10,2)
CVAX:
C      call errset (72,.false.,.false.,.false.,255)
 
  10  KWAY=0 
      READ (nsavtp,7) CTROLS 
    7 FORMAT (1P,5D14.7)
  
C TEST FOR LAST RUN 
 
      IF (nint(CTROLS(28)).EQ. -1) GO TO 12 
 
C TEST FOR DUMMY CONTROL BLOCK (ELIMINATED RERUN) 
      IF (nint(CTROLS(28)).EQ.0) GO TO 10 
C CHECK SOLUTION TIME 
 
      CPUTIM=RTIMER(X)
      IF (CPUTIM .GT.XMXSLT .AND. XMXSLT.GT.0.D0) GO TO 100 

      SAVE=XMXSLT 
 
C TERMINATE IF 90% OF CPU TIME IS USED, 
C ALLOWING 10% OF SOLUTION TIME FOR OUTPUT 
 
      XMXSLT=0.9d0*CPUTIM 

CLOLI IF (SAVE.EQ.0.D0) GO TO 100 
      IF (ABS(SAVE).LE.ZERO) GO TO 100 
 
C     ENTER ROUTINE TO PERFORM SIMULATION 
 
      WRITE(nouttp,9) XMXSLT 
    9 FORMAT('0SOLUTION TIME LIMIT USED    ',G14.2//) 
  100 XMCPUT=CPUTIM 
      XTMON=CLOCKF(X) 
      CALL SIMUL8 (KWAY) 

C     TEST FOR INITIAL CONDITIONS ONLY RUN 
      IF (KWAY.EQ.4) GO TO 10 
 
C     TEST FOR ERROR RETURN 
 
      IF (KWAY.EQ.10 .OR. KWAY.GT.12)  GO TO 15 
      REWIND inoutp 
 
C     ENTER POST PROCESSOR 
      CALL POST (lpost) 
      ldirac=ldirac.or.lpost
 
C     READ IN TYPE OF OUTPUT 
 
      REWIND inoutp 
      READ (inoutp)  CTROLS(71) 
      IF (nint(CTROLS(71)) .EQ. 0)  THEN
 
C     ENTER ROUTINE TO PRODUCE RESULTS PRINT OUT 
      CALL LISTR 
 
C     ENTER ROUTINE TO PRODUCE TIME PLOTS AND PRINTS 
 
         CALL MULPLT 

C     ENTER ROUTINE TO PRODUCE PRINTER PLOT 
 
         CALL PLOT 
 
       ELSE
  
C     AC OUTPUT:

         CALL ACLIST 
         CALL ACPLOT 
 
      END IF
C     TEST FOR OPERATOR TERMINATION 
 
      IF (KWAY.EQ.5 .OR. KWAY.EQ.11)  GO TO 13 
 
C     TEST FOR RE-OUTPUT RUN 
 
      IF (KWAY .EQ. 8) GO TO 20 
      GO TO 10 
   12 WRITE (neditp,70) CTROLS 
   70 FORMAT(1P,5D14.7,10X)

C     ENTER ROUTINE TO SAVE PROGRAM AND DATA 
   13 CALL SAVEPD(0) 
   15 continue
      if (ldirac) call pos000 ('DIRECTORY',lpost)
      WRITE (nouttp,'(''0SIMULATION PROGRAM HAS TERMINATED'')') 
      call stop2(1)
      stop 0

   20 WRITE (nouttp,22) 
   22 FORMAT(24H1RE-OUTPUT RUN COMPLETE.) 
      call stop2(2)
      stop 0
      END 
